// #include "/home/tikhon/Downloads/testlib-master/testlib.h"
#include "testlib.h"

#include <bits/stdc++.h>
using namespace std;

#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
map<string, string> params;

vector<string> mods = {"rand", "bad_a"};

string mode = "any";

const int UPTO = 1e7 + 100000;
const int PCNT = 1e6;

int min_factor[UPTO];  // min prime factor
int cntp = 0;
int primes[PCNT];  // all primes written

int max_factor[UPTO];   // max prime factor

int prev_dif_p[UPTO];
int len_to_prev[UPTO];
int total_factors[UPTO];

void generate_prime_numbers() {
    min_factor[1] = 1;
    for (int i = 2; i < UPTO; i++) {
        if (min_factor[i] == 0) {
            min_factor[i] = i;
            primes[cntp++] = i;
            for (int j = 0; j < cntp && primes[j] * i < UPTO; j++) {
                min_factor[i * primes[j]] = primes[j];
            }
        } else {
            for (int j = 0; primes[j] <= min_factor[i] && primes[j] * i < UPTO; j++) {
                min_factor[i * primes[j]] = primes[j];
            }
        }
    }
    for (int i = 1; i < UPTO; ++i) {
        max_factor[i] = max(max_factor[i / min_factor[i]], min_factor[i]);
    }

    prev_dif_p[1] = -1;
    len_to_prev[1] = 0;
    total_factors[1] = 1;
    for (int i = 2; i < UPTO; ++i) {
        if (min_factor[i] == min_factor[i / min_factor[i]]) {
            prev_dif_p[i] = prev_dif_p[i / min_factor[i]];
            len_to_prev[i] = 1 + len_to_prev[i / min_factor[i]];
        } else {
            prev_dif_p[i] = i / min_factor[i];
            len_to_prev[i] = 1;
        }
        total_factors[i] = total_factors[prev_dif_p[i]] * (len_to_prev[i] + 1);
    }
    cerr << "finished primes " << endl;
}

int generate_cool_k(int max_k, int average_ai = 5000'000, int lookahead = 30) {
    int best_k = max_k;
    double best_score = 1;

    for (int k = max_k; k >= (max_k * 7) / 8; --k) {
        double score = 0;
        for (int dvd = k; dvd <= k + lookahead; ++dvd) {
            score = max(score, (double)k / dvd * 2 * average_ai / (2 * average_ai + max_factor[dvd]));
        }
        if (score < best_score) {
            best_k = k;
            best_score = score;
        }
    }

    cerr << "best score for k = " << best_score << endl;
    return best_k;
}

int gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

// should purely devide in peaces of serten size
vector<int> generate_bad_a(int k, int lookahead = 30, int min_a = 1, int max_a = 10'000'000) {
    vector<float> score(max_a - min_a + 1, 0);
    for (int a1 = min_a; a1 <= max_a; ++a1) {
        for (int dvd = k; dvd <= k + lookahead; ++dvd) {
            score[a1 - min_a] = max(score[a1 - min_a], (float)k / dvd * (a1 / max_factor[dvd]) / a1 * max_factor[dvd]);
        }
    }
    float best_score = 1;
    for (int a1 = min_a; a1 <= max_a; ++a1) {
        if (score[a1 - min_a] != 0 && score[a1 - min_a] < best_score) {
            best_score = score[a1 - min_a];
        }
    }
    float treshold = (1 + best_score) / 2;

    vector<int> res;

    for (int a1 = min_a; a1 <= max_a; ++a1) {
        if (/*score[a1 - min_a] != 0 && */score[a1 - min_a] < treshold) {
            res.push_back(a1);
        }
    }

    cerr << "treshold score for a_i = " << treshold << endl;

    assert(!res.empty());
    return res;
}




vector<int> gen_a(int n, int k, int min_a, int max_a, int lookahead) {
    vector<int> a(n);
    if (mode == "rand") {
        for (int i = 0; i < n; ++i) {
            a[i] = rnd.next(min_a, max_a);
        }
    } else if (mode == "bad_a") {
        vector<int> bad = generate_bad_a(k, lookahead, min_a, max_a);
        for (int i = 0; i < n; ++i) {
            a[i] = rnd.any(all(bad));
        }
    } else {
        assert(0);
    }
    return a;
}

int generate_k_many_divisors(int max_k) {
    int s = sqrt(max_k);
    long long best_score = 0;
    int best_k = 1;

    long long cur_score = 0;
    int min_k = 1;
    for (int i = 0; i < s; ++i) {
        cur_score += total_factors[min_k + i] * total_factors[min_k + i];
    }

    for (int cur_k = min_k; cur_k <= max_k; ++cur_k) {
        if (best_score < cur_score) {
            best_score = cur_score;
            best_k = cur_k;
        }
        cur_score -= total_factors[cur_k] * total_factors[cur_k];
        cur_score += total_factors[cur_k + s] * total_factors[cur_k + s];
    }
    cerr << " k = " << best_k << " : " << best_score << endl;
    return best_k;
}

int gen_k(int min_a, int max_a, int lookahead) {
    if (params.count("k")) return stoi(params["k"]);
    if (params.count("k_prime_less")) {
        for (int k = stoi(params["k_prime_less"]); k >= 2; --k) {
            if (min_factor[k] == k) return k;
        }
        assert(0);
    }
    if (params.count("k_bad_less")) {
        return generate_cool_k(stoi(params["k_bad_less"]), (max_a + min_a) / 2, lookahead);
    }
    if (params.count("k_many_divisors_less")) {
        return generate_k_many_divisors(stoi(params["k_many_divisors_less"]));
    }
    assert(0);
}

int main(int argc, char* argv[]){
    generate_prime_numbers();
    cerr << fixed << setprecision(10);
    registerGen(argc, argv, 1);

    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        }
    }

    int n;
    n = stoi(params["n"]);

    if (params.count("mode"))
        mode = params["mode"];
    if (mode == "any")
        mode = rnd.any(mods);

    int min_a = 1;
    if (params.count("min_a")) min_a = stoi(params["min_a"]);
    int max_a = 10'000'000;
    if (params.count("max_a")) max_a = stoi(params["max_a"]);
    int lookahead = 30;
    if (params.count("lookahead")) lookahead = stoi(params["lookahead"]);

    int k = gen_k(min_a, max_a, lookahead);

    vector<int> a = gen_a(n, k, min_a, max_a, lookahead);

    // sort(all(a));

    cout << n << ' ' << k << '\n';
    cout << a[0];
    for (int i = 1; i < n; ++i) {
        cout << ' ' << a[i];
    }
    cout << '\n';

    return 0;
}
