#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld double
#define all(a) (a).begin(), (a).end()
// #define int long long


const int UPTO = 1e7 + 4000000;
const int PCNT = 1e6 + 300001;

int min_factor[UPTO];  // min prime factor
int cntp = 0;
int primes[PCNT];  // all primes written

void prepare_factors() {
    min_factor[1] = 1;
    for (int i = 2; i < UPTO; i++) {
        if (min_factor[i] == 0) {
            min_factor[i] = i;
            primes[cntp++] = i;
            for (int j = 0; j < cntp && primes[j] * i < UPTO; j++) {
                min_factor[i * primes[j]] = primes[j];
            }
        } else {
            for (int j = 0; primes[j] <= min_factor[i] && primes[j] * i < UPTO; j++) {
                min_factor[i * primes[j]] = primes[j];
            }
        }
    }
}




int n, k;
vector<int> a;

void read() {
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
}


bool isTimeLimit(ld TL) {
    return clock() > TL * CLOCKS_PER_SEC;
    // static int cnt = 0;
    // if (cnt % 32 == 0) {
    //     if (clock() > TL * CLOCKS_PER_SEC) return true;
    // }
    // ++cnt;
    // return false;
}

vector<int> find_divisors(int k) {
    vector<int> res = {1};
    while (min_factor[k] != 1) {
        int cur_factor = min_factor[k];
        int count = 0;
        while (min_factor[k] == cur_factor) {
            count += 1;
            k /= min_factor[k];
        }

        int sz = res.size();
        for (int i = 0; i < sz * count; ++i) {
            res.push_back(res[i] * cur_factor);
        }
    }
    return res;
}

void smax(ld& a, ld b) {
    a = max(a, b);
}

namespace golikov_solve {

ld solve(ld TIME_LIMIT) {

  int actual_split = 0;
  ld ans = 0;
  for (int xk = k; xk < k + 4000000 && !isTimeLimit(TIME_LIMIT); xk++) {
    ld const INF = -1;
    auto divk = find_divisors(xk);
    sort(divk.begin(), divk.end());
    int nd = int(divk.size());
    vector<vector<int>> forDiv(nd);
    for (int i = 0; i < nd; ++i) {
      for (int j = i; j < nd; ++j) {
        if (divk[j] % divk[i] == 0) {
          forDiv[i].push_back(j);
        }
      }
    }
    vector<ld> dp(nd, INF);
    dp[0] = 1;
    for (int x : a) {
      ld ix = ld(1) / x;
      for (int i = nd - 1; i >= 0; --i) {
        ld val = dp[i];
        if (val < 0) {
          continue;
        }

        val *= ix;
        dp[i] = INF;
        for (int j : forDiv[i]) {
          auto mult = divk[j] / divk[i];
          if (mult > x) {
            break;
          }

          smax(dp[j], val * (x / mult));
        }
      }
    }
    if (dp[nd - 1] != INF) {
      if (dp[nd - 1] > ans + 1e-20) {
        ans = dp[nd - 1];
        actual_split = xk;
      }
      // smax(ans, dp[nd - 1]);
    }
  }
  
  cerr << "golikov_split = " << actual_split << " : " << (actual_split - k) << " from k" << endl;
  return ans * k;
}

}  // namespace golikov_solve


namespace random_stuff {

double solve(ld TIME_LIMIT) {
    if (k == 1) return 1;
    if (n == 1) {
        return (ld)(a[0] / k) / a[0] * k;
    }

    ld res = 0;

    while (!isTimeLimit(TIME_LIMIT)) {
        random_shuffle(all(a));
        ll parts = 1;
        for (int i = 0; i < n; ++i) {
            if (parts * a[i] >= k) {
                int need = (k + parts - 1) / parts;
                res = max(res, (ld)k / parts * (a[i] / need) / a[i]);
                break;
            } else {
                parts *= a[i];
            }
        }
    }

    return res;
}

}  // namespace random_stuff


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    read();
    prepare_factors();

    cout << fixed << setprecision(20);

    ld ans_g = golikov_solve::solve(1.55);

    ld ans_ann = random_stuff::solve(1.96);

    if (ans_g >= max(ans_g, ans_ann) - 5e-10) {
        cerr << "golikov found" << endl;
    }
    if (ans_ann >= max(ans_g, ans_ann) - 5e-10) {
        cerr << "stupid found" << endl;
    }

    cout << max(ans_g, ans_ann) << '\n';


    return 0;
}
