#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld double
#define all(a) (a).begin(), (a).end()




const int UPTO = 1e7 + 4000000;
const int PCNT = 1e6 + 300000;

int min_factor[UPTO];  // min prime factor
int cntp = 0;
int primes[PCNT];  // all primes written

void prepare_factors() {
    min_factor[1] = 1;
    for (int i = 2; i < UPTO; i++) {
        if (min_factor[i] == 0) {
            min_factor[i] = i;
            primes[cntp++] = i;
            for (int j = 0; j < cntp && primes[j] * i < UPTO; j++) {
                min_factor[i * primes[j]] = primes[j];
            }
        } else {
            for (int j = 0; primes[j] <= min_factor[i] && primes[j] * i < UPTO; j++) {
                min_factor[i * primes[j]] = primes[j];
            }
        }
    }
}




int n, k;
vector<int> a;

void read() {
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
}


bool isTimeLimit(ld TL) {
    return clock() > TL * CLOCKS_PER_SEC;
    // static int cnt = 0;
    // if (cnt % 32 == 0) {
    //     if (clock() > TL * CLOCKS_PER_SEC) return true;
    // }
    // ++cnt;
    // return false;
}

vector<int> find_divisors(int k) {
    vector<int> res = {1};
    while (min_factor[k] != 1) {
        int cur_factor = min_factor[k];
        int count = 0;
        while (min_factor[k] == cur_factor) {
            count += 1;
            k /= min_factor[k];
        }

        int sz = res.size();
        for (int i = 0; i < sz * count; ++i) {
            res.push_back(res[i] * cur_factor);
        }
    }
    return res;
}

void smax(ld& a, ld b) {
    a = max(a, b);
}

namespace golikov_solve {

ld solve(ld TIME_LIMIT) {

  int actual_split = 0;
  ld ans = 0;
  for (int xk = k; xk < k + 4000000 && !isTimeLimit(TIME_LIMIT); xk++) {
    ld const INF = -1;
    auto divk = find_divisors(xk);
    sort(divk.begin(), divk.end());
    int nd = int(divk.size());
    vector<vector<int>> forDiv(nd);
    for (int i = 0; i < nd; ++i) {
      for (int j = i; j < nd; ++j) {
        if (divk[j] % divk[i] == 0) {
          forDiv[i].push_back(j);
        }
      }
    }
    vector<ld> dp(nd, INF);
    dp[0] = 1;
    for (int x : a) {
      ld ix = ld(1) / x;
      for (int i = nd - 1; i >= 0; --i) {
        ld val = dp[i];
        if (val < 0) {
          continue;
        }

        val *= ix;
        dp[i] = INF;
        for (int j : forDiv[i]) {
          auto mult = divk[j] / divk[i];
          if (mult > x) {
            break;
          }

          smax(dp[j], val * (x / mult));
        }
      }
    }
    if (dp[nd - 1] != INF) {
      if (dp[nd - 1] > ans + 1e-20) {
        ans = dp[nd - 1];
        actual_split = xk;
      }
      // smax(ans, dp[nd - 1]);
    }
  }
  
  cerr << "g_split = " << actual_split << " : " << (actual_split - k) << " from k" << endl;
  return ans * k;
}

}  // namespace golikov_solve





const int inf = 1e9 + 7;

// const int maxa = 1e4 + 2;

// const int maxk = 1e6 + 2;
const int maxsqk = 4e3;//1e3 + 2;

const int maxn = 1e2 + 2;


ld dp[maxn][2 * maxsqk];

vector<ld> back_a;

void relax(int i, ll d1, ll d, int ml) {
    if (d1 * d1 >= k) d1 = maxsqk + (k + d1 - 1) / d1;
    if (d * d >= k) d = maxsqk + (k + d - 1) / d;
    if (dp[i][d] * back_a[i] * ml > dp[i + 1][d1]) {
        dp[i + 1][d1] = dp[i][d] * back_a[i] * ml;
    }
}

ld solve() {
    dp[0][1] = 1;

    // forward
    for (int i = 0; i < n; i++) {
        for (int d = 1; d * d <= k; d++) {
            for (int s1 = 1; s1 * s1 <= a[i]; s1++) {
                relax(i, d * s1, d, a[i] / s1);
                relax(i, d * (a[i] / s1), d, s1);
                relax(i, ((k + d - 1) / d) * s1, (k + d - 1) / d, a[i] / s1);
                relax(i, ((k + d - 1) / d) * (a[i] / s1), (k + d - 1) / d, s1);
            }
        }
    }

    return dp[n][maxsqk + 1] * k;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    prepare_factors();
    read();

    back_a.resize(n);
    for (int i = 0; i < n; ++i) back_a[i] = (ld)1 / a[i];

    ld step_count = 0;
    for (int i = 0; i < n; ++i) {
        step_count += sqrt(a[i]);
    }
    step_count *= sqrt(k);

    ld res = 0;
    if (step_count < 6e6) {
        res = solve();
    }

    cout << fixed << setprecision(20);
    ld golikov_ans = golikov_solve::solve(0.49);

    cout << max(golikov_ans, res) << '\n';

    // cout << solve() << '\n';

    return 0;
}
