#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

const int MAXN = 200'000, mod = (int) 1e9 + 7;

const int maxn[9] = {MAXN, 300, 3000, 3000, MAXN, 100'000, MAXN, 100'000, MAXN};
const int maxq[9] = {MAXN, 300, 3000, 3000, MAXN, 100'000, MAXN, 100'000, MAXN};

int getp(vector<int> &p, int v) {
    return p[v] == v ? v : p[v] = getp(p, p[v]);
}

bool merge(vector<int> &p, int x, int y) {
    x = getp(p, x);
    y = getp(p, y);
    if (x == y) {
        return false;
    } else {
        p[x] = y;
        return true;
    }
}

class LCA {
public:
    int n;
    vector<pair<int, int>> st;
    vector<int> tin, dist, lg;
    vector<vector<int>> g;
    vector<vector<pair<int, int>>> ST;

    void dfs(int v, int pr, int d) {
        tin[v] = st.size();
        dist[v] = d;
        st.push_back({d, v});
        for (auto x : g[v]) {
            if (x == pr) continue;
            dfs(x, v, d + 1);
            st.push_back({d, v});
        }
    }

    LCA(vector<vector<int>>& _g, int stv) {
        n = (int) _g.size();
        g = _g;
        tin.resize(n);
        dist.resize(n);
        dfs(stv, -1, 0);
        int m = st.size();
        lg.resize(m + 1);
        for (int i = 2; i <= m; i++) lg[i] = lg[i / 2] + 1;
        int maxlg = lg[m] + 1;
        ST.resize(maxlg);
        ST[0] = st;
        for (int i = 1; i < maxlg; i++) {
            ST[i].resize(m - (1 << i) + 1);
            for (int j = 0; j < m - (1 << i) + 1; j++) {
                ST[i][j] = min(ST[i - 1][j], ST[i - 1][j + (1 << (i - 1))]);
            }
        }
    }

    int lca(int x, int y) {
        int l = min(tin[x], tin[y]), r = max(tin[x], tin[y]);
        int LG = lg[r - l + 1];
        pair<int, int> res = min(ST[LG][l], ST[LG][r - (1 << LG) + 1]);
        return res.second;
    }

    int distance(int x, int y) {
        return dist[x] + dist[y] - 2 * dist[lca(x, y)];
    }
};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());

    int n = inf.readInt(1, maxn[group], "N");
    inf.readEoln();

    vector<int> dsu(n);
    iota(dsu.begin(), dsu.end(), 0);

    vector<int> p = inf.readInts(n - 1, 1, n, "p");
    inf.readEoln();

    vector<vector<int>> g(n);

    for (int i = 0; i < n - 1; ++i) {
        int x = i + 2;
        int y = p[i];
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
        ensuref(merge(dsu, x - 1, y - 1), "Tree can't contain cycles or loops");
        if (group == 2 || group == 5 || group == 6) {
            ensuref(y + 1 == x, "Tree isn`t bamboo");
        }
    }
    LCA G(g, 0);
    for (int i = 0; i < n; i++) {
        int l = inf.readInt(1, mod - 1, "l");
        inf.readSpace();
        inf.readInt(l, mod - 1, "r");
        inf.readEoln();
    }
    int q = inf.readInt(1, maxq[group], "q");
    inf.readEoln();
    long long sum = 0;
    for (int i = 0; i < q; i++) {
        int a = inf.readInt(1, n, "a");
        inf.readSpace();
        int b = inf.readInt(1, n, "b");
        inf.readSpace();
        int c = inf.readInt(1, n, "c");
        inf.readSpace();
        int d = inf.readInt(1, n, "d");
        inf.readEoln();
        sum += G.distance(a - 1, b - 1) + G.distance(c - 1, d - 1);
        ensuref(G.distance(a - 1, b - 1) == G.distance(c - 1, d - 1), "Paths must be the same length");
    }
    if (group == 4) {
        ensuref(sum <= 100'000'000, "Incorrect sum of distance of all path for 4 group");
    }
    inf.readEof();
}
