#include "bits/stdc++.h"

using namespace std;

const int mod = (int) 1e9 + 7;

int inv(int x) {
    int res = 1, n = mod - 2;
    while (n) {
        if (n & 1) {
            res = res * 1ll * x % mod;
        }
        x = x * 1ll * x % mod;
        n /= 2;
    }
    return res;
}

const int N = (int) 2e5 + 22;
vector<int> g[N];
pair<int, int> a[N];
int ans = 1;
int n, q, h[N], p[N], used[N], root[N];

void merge(int v, int u) {
    v = root[v], u = root[u];
    if (v != u) {
        if (a[v].first <= a[v].second) {
            ans = ans * 1ll * inv(a[v].second - a[v].first + 1) % mod;
        }
        if (a[u].first <= a[u].second) {
            ans = ans * 1ll * inv(a[u].second - a[u].first + 1) % mod;
        }
        for (int i = 0; i < n; i++) {
            if (root[i] == v) {
                root[i] = u;
                a[u].first = max(a[u].first, a[i].first);
                a[u].second = min(a[u].second, a[i].second);
            }
        }
        if (a[u].first > a[u].second) {
            ans = 0;
        } else {
            ans = ans * 1ll * (a[u].second - a[u].first + 1) % mod;
        }
    }
}

void dfs(int v) {
    for (auto u : g[v]) {
        h[u] = h[v] + 1;
        p[u] = v;
        dfs(u);
    }
}

vector<int> get_path(int v, int u) {
    vector<int> l, r;
    while (v != u) {
        if (h[v] >= h[u]) {
            l.push_back(v);
            v = p[v];
        } else {
            r.push_back(u);
            u = p[u];
        }
    }
    l.push_back(v);
    for (int i = (int) r.size() - 1; i >= 0; i--) {
        l.push_back(r[i]);
    }
    return l;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i++) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        root[i] = i;
        cin >> a[i].first >> a[i].second;
        ans = ans * 1ll * (a[i].second - a[i].first + 1) % mod;
    }
    dfs(0);
    cin >> q;
    while (q--) {
        int v, u, x, y;
        cin >> v >> u >> x >> y;
        v--, u--, x--, y--;
        auto vu = get_path(v, u);
        auto xy = get_path(x, y);
        assert((int) vu.size() == (int) xy.size());
        for (int i = 0; i < (int) vu.size(); i++) {
            merge(vu[i], xy[i]);
        }
        cout << ans << '\n';
    }
}