#include "bits/stdc++.h"

using namespace std;

const int mod = (int) 1e9 + 7;
const int N = (int) 2e5 + 22;
vector<int> g[N], graph[N];
pair<int, int> a[N];
int n, q, h[N], p[N], used[N];

void dfs(int v) {
    for (auto u : g[v]) {
        h[u] = h[v] + 1;
        p[u] = v;
        dfs(u);
    }
}

void dfs2(int v, vector<int>& ts) {
    ts.push_back(v);
    used[v] = 1;
    for (auto u : graph[v]) {
        if (!used[u]) {
            dfs2(u, ts);
        }
    }
}

vector<int> get_path(int v, int u) {
    vector<int> l, r;
    while (v != u) {
        if (h[v] >= h[u]) {
            l.push_back(v);
            v = p[v];
        } else {
            r.push_back(u);
            u = p[u];
        }
    }
    l.push_back(v);
    for (int i = (int) r.size() - 1; i >= 0; i--) {
        l.push_back(r[i]);
    }
    return l;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i++) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    dfs(0);
    cin >> q;
    while (q--) {
        int v, u, x, y;
        cin >> v >> u >> x >> y;
        v--, u--, x--, y--;
        auto vu = get_path(v, u);
        auto xy = get_path(x, y);
        assert((int) vu.size() == (int) xy.size());
        for (int i = 0; i < (int) vu.size(); i++) {
            graph[vu[i]].push_back(xy[i]);
            graph[xy[i]].push_back(vu[i]);
        }
        fill(used, used + n, 0);
        int ans = 1;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                vector<int> ts;
                dfs2(i, ts);
                int l = 0, r = (int) 1e9 + 22;
                for (auto v : ts) {
                    l = max(l, a[v].first);
                    r = min(r, a[v].second);
                }
                if (l > r) {
                    ans = 0;
                } else {
                    ans = ans * 1ll * (r - l + 1) % mod;
                }
            }
        }
        cout << ans << '\n';
    }
}