#include "bits/stdc++.h"

using namespace std;

double start = clock();

const int mod = (int) 1e9 + 7;

int inv(int x) {
    int res = 1, n = mod - 2;
    while (n) {
        if (n & 1) {
            res = res * 1ll * x % mod;
        }
        x = x * 1ll * x % mod;
        n /= 2;
    }
    return res;
}

const int N = (int) 2e5 + 22;
vector<int> g[N];
pair<int, int> a[N];
int ans = 1;
int n, q, h[N], p[N], used[N], root[N];

class LCA {
public:
    int n;
    vector<pair<int, int>> st;
    vector<int> tin, dist, lg;
    vector<vector<int>> g;
    vector<vector<pair<int, int>>> ST;

    void dfs(int v, int pr, int d) {
        tin[v] = st.size();
        dist[v] = d;
        st.push_back({d, v});
        for (auto x : g[v]) {
            if (x == pr) continue;
            dfs(x, v, d + 1);
            st.push_back({d, v});
        }
    }

    LCA(vector<vector<int>>& _g, int stv) {
        n = (int) _g.size();
        g = _g;
        tin.resize(n);
        dist.resize(n);
        dfs(stv, -1, 0);
        int m = st.size();
        lg.resize(m + 1);
        for (int i = 2; i <= m; i++) lg[i] = lg[i / 2] + 1;
        int maxlg = lg[m] + 1;
        ST.resize(maxlg);
        ST[0] = st;
        for (int i = 1; i < maxlg; i++) {
            ST[i].resize(m - (1 << i) + 1);
            for (int j = 0; j < m - (1 << i) + 1; j++) {
                ST[i][j] = min(ST[i - 1][j], ST[i - 1][j + (1 << (i - 1))]);
            }
        }
    }

    int lca(int x, int y) {
        int l = min(tin[x], tin[y]), r = max(tin[x], tin[y]);
        int LG = lg[r - l + 1];
        pair<int, int> res = min(ST[LG][l], ST[LG][r - (1 << LG) + 1]);
        return res.second;
    }

    int distance(int x, int y) {
        return dist[x] + dist[y] - 2 * dist[lca(x, y)];
    }
};

int get(int v) {
    if (v == root[v]) {
        return v;
    }
    return root[v] = get(root[v]);
}

void merge(int v, int u) {
    v = get(v), u = get(u);
    if (v != u) {
        if (a[v].first <= a[v].second) {
            ans = ans * 1ll * inv(a[v].second - a[v].first + 1) % mod;
        }
        if (a[u].first <= a[u].second) {
            ans = ans * 1ll * inv(a[u].second - a[u].first + 1) % mod;
        }
        a[u].first = max(a[u].first, a[v].first);
        a[u].second = min(a[u].second, a[v].second);
        root[v] = u;
        if (a[u].first > a[u].second) {
            ans = 0;
        } else {
            ans = ans * 1ll * (a[u].second - a[u].first + 1) % mod;
        }
    }
}

void dfs(int v) {
    for (auto u : g[v]) {
        h[u] = h[v] + 1;
        p[u] = v;
        dfs(u);
    }
}

vector<int> get_path(int v, int u) {
    vector<int> l, r;
    while (v != u) {
        if (h[v] >= h[u]) {
            l.push_back(v);
            v = p[v];
        } else {
            r.push_back(u);
            u = p[u];
        }
    }
    l.push_back(v);
    for (int i = (int) r.size() - 1; i >= 0; i--) {
        l.push_back(r[i]);
    }
    return l;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<vector<int>> G(n);
    for (int i = 1; i < n; i++) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
        G[v].push_back(i);
        G[i].push_back(v);
    }
    LCA lca(G, 0);
    for (int i = 0; i < n; i++) {
        root[i] = i;
        cin >> a[i].first >> a[i].second;
        ans = ans * 1ll * (a[i].second - a[i].first + 1) % mod;
    }
    dfs(0);
    cin >> q;
    for (int t = 0; t < q; t++) {
        int v, u, x, y;
        cin >> v >> u >> x >> y;
        v--, u--, x--, y--;
        if (ans == 0 || (clock() - start) / CLOCKS_PER_SEC > 5.0) {
            //
        } else if ((clock() - start) / CLOCKS_PER_SEC < 3.0) {
            auto vu = get_path(v, u);
            auto xy = get_path(x, y);
            assert((int) vu.size() == (int) xy.size());
            for (int i = 0; i < (int) vu.size(); i++) {
                merge(vu[i], xy[i]);
            }
        } else {
            int w = lca.lca(v, u);
            int z = lca.lca(x, y);
            while (v != w && x != z) {
                merge(v, x);
                v = p[v];
                x = p[x];
            }
            while (u != w && y != z) {
                merge(u, y);
                u = p[u];
                y = p[y];
            }
        }
        cout << ans << '\n';
    }
}