#include "bits/stdc++.h"

using namespace std;

const int mod = (int) 1e9 + 7, k = 2000149;

int inv(int x) {
    int res = 1, n = mod - 2;
    while (n) {
        if (n & 1) {
            res = res * 1ll * x % mod;
        }
        x = x * 1ll * x % mod;
        n /= 2;
    }
    return res;
}

const int N = (int) 2e5 + 22;
vector<int> g[N];
pair<int, int> a[N];
vector<int> comp[N];
int ans = 1;
int n, q, root[N], h[N], pr[N], pw[N], head[N], id[N], sz[N], ts[N], t = 0;

void get_sz(int v) {
    sz[v] = 1;
    for (auto u : g[v]) {
        h[u] = h[v] + 1;
        pr[u] = v;
        get_sz(u);
        sz[v] += sz[u];
    }
}

void dfs(int v, int pr, int rt) {
    head[v] = rt;
    ts[t] = v;
    id[v] = t++;
    sort(g[v].begin(), g[v].end(), [&] (int i, int j) {
        return sz[i] < sz[j];
    });
    if (!g[v].empty()) {
        dfs(g[v][0], v, rt);
    }
    for (int i = 1; i < (int) g[v].size(); i++) {
        dfs(g[v][i], v, g[v][i]);
    }
}

int tree[4 * N], tree2[4 * N];

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = tree2[v] = ts[l];
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tree[v] = (tree[v * 2 + 1] * 1ll * pw[r - m] + tree[v * 2 + 2]) % mod;
    tree2[v] = (tree2[v * 2 + 1] + tree2[v * 2 + 2] * 1ll * pw[m - l]) % mod;
}

void update(int v, int l, int r, int i, int x) {
    if (l + 1 == r) {
        tree[v] = tree2[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) {
        update(v * 2 + 1, l, m, i, x);
    } else {
        update(v * 2 + 2, m, r, i, x);
    }
    tree[v] = (tree[v * 2 + 1] * 1ll * pw[r - m] + tree[v * 2 + 2]) % mod;
    tree2[v] = (tree2[v * 2 + 1] + tree2[v * 2 + 2] * 1ll * pw[m - l]) % mod;
}

int get(int v, int l, int r, int l1, int r1) {
    if (l1 >= r || l >= r1) {
        return 0;
    }
    if (l1 <= l && r <= r1) {
        return tree[v];
    }
    int m = (l + r) / 2;
    int resl = get(v * 2 + 1, l, m, l1, r1);
    int resr = get(v * 2 + 2, m, r, l1, r1);
    return (resl * 1ll * pw[max(0, min(r1, r) - max(m, l1))] + resr) % mod;
}

int get2(int v, int l, int r, int l1, int r1) {
    if (l1 >= r || l >= r1) {
        return 0;
    }
    if (l1 <= l && r <= r1) {
        return tree2[v];
    }
    int m = (l + r) / 2;
    int resl = get2(v * 2 + 1, l, m, l1, r1);
    int resr = get2(v * 2 + 2, m, r, l1, r1);
    return (resl + resr * 1ll * pw[max(0, min(r1, m) - max(l, l1))]) % mod;
}

int get(int l, int r) {
    if (l <= r) {
        return get(0, 0, n, l, r + 1);
    } else {
        return get2(0, 0, n, r, l + 1);
    }
}

vector<pair<int, int>> get_path(int v, int u) {
    vector<pair<int, int>> l, r;
    while (head[v] != head[u]) {
        if (h[head[v]] > h[head[u]]) {
            l.push_back({id[v], id[head[v]]});
            v = pr[head[v]];
        } else {
            r.push_back({id[head[u]], id[u]});
            u = pr[head[u]];
        }
    }
    l.push_back({id[v], id[u]});
    reverse(r.begin(), r.end());
    for (auto el : r) {
        l.push_back(el);
    }
    return l;
}

void merge(int v, int u) {
    v = root[v], u = root[u];
    assert(v != u);
    if ((int) comp[v].size() > (int) comp[u].size()) {
        swap(v, u);
    }
    if (a[v].first <= a[v].second) {
        ans = ans * 1ll * inv(a[v].second - a[v].first + 1) % mod;
    }
    if (a[u].first <= a[u].second) {
        ans = ans * 1ll * inv(a[u].second - a[u].first + 1) % mod;
    }
    a[u].first = max(a[u].first, a[v].first);
    a[u].second = min(a[u].second, a[v].second);
    for (auto i : comp[v]) {
        comp[u].push_back(i);
        root[i] = u;
        update(0, 0, n, id[i], u);
    }
    if (a[u].first > a[u].second) {
        ans = 0;
    } else {
        ans = ans * 1ll * (a[u].second - a[u].first + 1) % mod;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    pw[0] = 1;
    for (int i = 1; i < N; i++) {
        pw[i] = pw[i - 1] * 1ll * k % mod;
    }
    cin >> n;
    for (int i = 1; i < n; i++) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        root[i] = i;
        comp[i].push_back(i);
        cin >> a[i].first >> a[i].second;
        ans = ans * 1ll * (a[i].second - a[i].first + 1) % mod;
    }
    get_sz(0);
    dfs(0, -1, 0);
    build(0, 0, n);
    cin >> q;
    for (int t = 0; t < q; t++) {
        int v, u, x, y;
        cin >> v >> u >> x >> y;
        v--, u--, x--, y--;
        auto vu = get_path(v, u);
        auto xy = get_path(x, y);
        reverse(vu.begin(), vu.end());
        reverse(xy.begin(), xy.end());
        while (!vu.empty()) {
            auto [l, r] = vu.back();
            auto [l2, r2] = xy.back();
            int d = min(abs(l - r), abs(l2 - r2)) + 1;
            int m = l + (l <= r ? d - 1 : -(d - 1));
            int m2 = l2 + (l2 <= r2 ? d - 1 : -(d - 1));
            if (get(l, m) != get(l2, m2)) {
                int vl = 0, vr = d;
                while (vl + 1 < vr) {
                    int vm = (vl + vr) / 2;
                    int M = l + (l <= r ? vm - 1 : -(vm - 1));
                    int M2 = l2 + (l2 <= r2 ? vm - 1 : -(vm - 1));
                    if (get(l, M) != get(l2, M2)) {
                        vr = vm;
                    } else {
                        vl = vm;
                    }
                }
                int pos = l + (l <= r ? vr - 1 : -(vr - 1));
                int pos2 = l2 + (l2 <= r2 ? vr - 1 : -(vr - 1));
                merge(ts[pos], ts[pos2]);
                continue;
            }
            if (m != r) {
                vu.back() = {m + (l <= r ? 1 : -1), r};
            } else {
                vu.pop_back();
            }
            if (m2 != r2) {
                xy.back() = {m2 + (l2 <= r2 ? 1 : -1), r2};
            } else {
                xy.pop_back();
            }
        }
        cout << ans << '\n';
    }
}
