/*
    author:  Maksim1744
    created: 18.02.2023 13:13:05
*/

#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;

#define mp   make_pair
#define pb   push_back
#define eb   emplace_back

#define sum(a)     ( accumulate ((a).begin(), (a).end(), 0ll))
#define mine(a)    (*min_element((a).begin(), (a).end()))
#define maxe(a)    (*max_element((a).begin(), (a).end()))
#define mini(a)    ( min_element((a).begin(), (a).end()) - (a).begin())
#define maxi(a)    ( max_element((a).begin(), (a).end()) - (a).begin())
#define lowb(a, x) ( lower_bound((a).begin(), (a).end(), (x)) - (a).begin())
#define uppb(a, x) ( upper_bound((a).begin(), (a).end(), (x)) - (a).begin())

template<typename T>             vector<T>& operator--            (vector<T> &v){for (auto& i : v) --i;            return  v;}
template<typename T>             vector<T>& operator++            (vector<T> &v){for (auto& i : v) ++i;            return  v;}
template<typename T>             istream& operator>>(istream& is,  vector<T> &v){for (auto& i : v) is >> i;        return is;}
template<typename T>             ostream& operator<<(ostream& os,  vector<T>  v){for (auto& i : v) os << i << ' '; return os;}
template<typename T, typename U> pair<T,U>& operator--           (pair<T, U> &p){--p.first; --p.second;            return  p;}
template<typename T, typename U> pair<T,U>& operator++           (pair<T, U> &p){++p.first; ++p.second;            return  p;}
template<typename T, typename U> istream& operator>>(istream& is, pair<T, U> &p){is >> p.first >> p.second;        return is;}
template<typename T, typename U> ostream& operator<<(ostream& os, pair<T, U>  p){os << p.first << ' ' << p.second; return os;}
template<typename T, typename U> pair<T,U> operator-(pair<T,U> a, pair<T,U> b){return mp(a.first-b.first, a.second-b.second);}
template<typename T, typename U> pair<T,U> operator+(pair<T,U> a, pair<T,U> b){return mp(a.first+b.first, a.second+b.second);}
template<typename T, typename U> void umin(T& a, U b){if (a > b) a = b;}
template<typename T, typename U> void umax(T& a, U b){if (a < b) a = b;}

#ifdef HOME
#define SHOW_COLORS
#include "/mnt/c/Libs/tools/print.cpp"
#else
#define show(...) void(0)
#define debugf(fun)   fun
#define debugv(var)   var
#define mclock    void(0)
#define shows     void(0)
#define debug  if (false)
#define OSTREAM(...)    ;
#define OSTREAM0(...)   ;
#endif

vector<int> lca_ind;
vector<vector<int>> lca_sparse;
vector<int> lca_p2;
vector<int> lca_depth;
void build_lca_sparse(vector<vector<int>>& g, int root = 0) {
    int n = g.size();
    vector<int> euler;
    lca_ind.resize(n);
    lca_depth.assign(n, -1);
    function<void(int, int)> dfs = [&](int v, int depth) {
        lca_ind[v] = euler.size();
        euler.pb(v);
        lca_depth[v] = depth;
        for (auto k : g[v]) {
            if (lca_depth[k] == -1) {
                dfs(k, depth + 1);
                euler.pb(v);
            }
        }
    };
    dfs(root, 0);
    int m = euler.size();
    int log = 1;
    while ((1 << log) < m)
        ++log;
    lca_sparse.resize(log);
    lca_sparse[0].resize(m);
    lca_p2.resize(m + 1);
    int pp2 = 0;
    for (int i = 1; i < lca_p2.size(); ++i) {
        if (1 << (pp2 + 1) <= i)
            ++pp2;
        lca_p2[i] = pp2;
    }
    lca_p2[0] = 0;
    for (int i = 0; i < m; ++i)
        lca_sparse[0][i] = euler[i];
    for (int i = 1; i < log; ++i) {
        lca_sparse[i].assign(m, 0);
        for (int j = 0; j < m - (1 << (i - 1)); ++j) {
            int v1 = lca_sparse[i - 1][j], v2 = lca_sparse[i - 1][j + (1 << (i - 1))];
            if (lca_depth[v1] < lca_depth[v2])
                lca_sparse[i][j] = v1;
            else
                lca_sparse[i][j] = v2;
        }
    }
}

int get_lca(int u, int v) {
    if (u == v)
        return u;
    u = lca_ind[u];
    v = lca_ind[v];
    if (u > v)
        swap(u, v);
    int v1 = lca_sparse[lca_p2[v - u + 1]][u], v2 = lca_sparse[lca_p2[v - u + 1]][v - (1 << lca_p2[v - u + 1]) + 1];
    if (lca_depth[v1] < lca_depth[v2])
        return v1;
    else
        return v2;
}

int dist(int u, int v) {
    return lca_depth[u] + lca_depth[v] - 2 * lca_depth[get_lca(u, v)];
}

namespace mint_ns {
template<auto P>
struct Modular {
    using value_type = decltype(P);
    value_type value;

    Modular(long long k = 0) : value(norm(k)) {}

    friend Modular<P>& operator += (      Modular<P>& n, const Modular<P>& m) { n.value += m.value; if (n.value >= P) n.value -= P; return n; }
    friend Modular<P>  operator +  (const Modular<P>& n, const Modular<P>& m) { Modular<P> r = n; return r += m; }

    friend Modular<P>& operator -= (      Modular<P>& n, const Modular<P>& m) { n.value -= m.value; if (n.value < 0)  n.value += P; return n; }
    friend Modular<P>  operator -  (const Modular<P>& n, const Modular<P>& m) { Modular<P> r = n; return r -= m; }
    friend Modular<P>  operator -  (const Modular<P>& n)                      { return Modular<P>(-n.value); }

    friend Modular<P>& operator *= (      Modular<P>& n, const Modular<P>& m) { n.value = n.value * 1ll * m.value % P; return n; }
    friend Modular<P>  operator *  (const Modular<P>& n, const Modular<P>& m) { Modular<P> r = n; return r *= m; }

    friend Modular<P>& operator /= (      Modular<P>& n, const Modular<P>& m) { return n *= m.inv(); }
    friend Modular<P>  operator /  (const Modular<P>& n, const Modular<P>& m) { Modular<P> r = n; return r /= m; }

    Modular<P>& operator ++ (   ) { return *this += 1; }
    Modular<P>& operator -- (   ) { return *this -= 1; }
    Modular<P>  operator ++ (int) { Modular<P> r = *this; *this += 1; return r; }
    Modular<P>  operator -- (int) { Modular<P> r = *this; *this -= 1; return r; }

    friend bool operator == (const Modular<P>& n, const Modular<P>& m) { return n.value == m.value; }
    friend bool operator != (const Modular<P>& n, const Modular<P>& m) { return n.value != m.value; }

    explicit    operator       int() const { return value; }
    explicit    operator      bool() const { return value; }
    explicit    operator long long() const { return value; }

    constexpr static value_type mod()      { return     P; }

    value_type norm(long long k) {
        if (!(-P <= k && k < P)) k %= P;
        if (k < 0) k += P;
        return k;
    }

    Modular<P> inv() const {
        value_type a = value, b = P, x = 0, y = 1;
        while (a != 0) { value_type k = b / a; b -= k * a; x -= k * y; swap(a, b); swap(x, y); }
        return Modular<P>(x);
    }
};
template<auto P> Modular<P> pow(Modular<P> m, long long p) {
    Modular<P> r(1);
    while (p) {
        if (p & 1) r *= m;
        m *= m;
        p >>= 1;
    }
    return r;
}

template<auto P> ostream& operator << (ostream& o, const Modular<P>& m) { return o << m.value; }
template<auto P> istream& operator >> (istream& i,       Modular<P>& m) { long long k; i >> k; m.value = m.norm(k); return i; }
template<auto P> string   to_string(const Modular<P>& m) { return to_string(m.value); }

using Mint = Modular<1000000007>;
// using Mint = Modular<998244353>;
// using Mint = long double;

vector<Mint> f, fi;
void init_C(int n) {
    f.assign(n, 1); fi.assign(n, 1);
    for (int i = 2; i < n; ++i) f[i] = f[i - 1] * i;
    fi.back() = Mint(1) / f.back();
    for (int i = n - 2; i >= 0; --i) fi[i] = fi[i + 1] * (i + 1);
}
Mint C(int n, int k) {
    if (k < 0 || k > n) return 0;
    else return f[n] * fi[k] * fi[n - k];
}
}
using namespace mint_ns;

namespace segtree {

// This implementation is disgusting, but it seems to work and do it faster than previous version.

template<typename Item>
Item tree_merge(const Item& a, const Item& b) {
    Item i;
    i.update(a, b);
    return i;
}

template<typename Item, bool lazy>
struct Pusher {};

template<typename Item>
struct Pusher<Item, false> {
    void push(const vector<Item>&, int, int, int) {}
    Item ask_on_segment(const vector<Item>& tree, int n, int l, int r) {
        l |= n;
        r |= n;
        Item resl, resr;
        while (l <= r) {
            if (l & 1) {
                resl = tree_merge(resl, tree[l]);
                ++l;
            }
            if (!(r & 1)) {
                resr = tree_merge(tree[r], resr);
                --r;
            }
            l >>= 1;
            r >>= 1;
        }
        return tree_merge(resl, resr);
    }
    void push_point(const vector<Item>&, int, int) {}

    template<typename P>
    int lower_bound(const vector<Item>& tree, int n, int l, P p) {
        Item cur;
        if (p(cur)) return l - 1;
        l |= n;
        int r = n | (n - 1);
        // carefully go up
        while (true) {
            if (p(tree_merge(cur, tree[l]))) {
                break;
            }
            if (l == r) return n;
            if (l & 1) {
                cur = tree_merge(cur, tree[l]);
                ++l;
            }
            l >>= 1;
            r >>= 1;
        }

        // usual descent from l
        while (l < n) {
            if (p(tree_merge(cur, tree[l * 2]))) {
                l = l * 2;
            } else {
                cur = tree_merge(cur, tree[l * 2]);
                l = l * 2 + 1;
            }
        }
        return (l ^ n);
    }

    template<typename P>
    int lower_bound_rev(const vector<Item>& tree, int n, int r, P p) {
        Item cur;
        if (p(cur)) return r + 1;
        r |= n;
        int l = n;
        // carefully go up
        while (true) {
            if (p(tree_merge(tree[r], cur))) {
                break;
            }
            if (l == r) return -1;
            if (!(r & 1)) {
                cur = tree_merge(tree[r], cur);
                --r;
            }
            l >>= 1;
            r >>= 1;
        }

        // usual descent from r
        while (r < n) {
            if (p(tree_merge(tree[r * 2 + 1], cur))) {
                r = r * 2 + 1;
            } else {
                cur = tree_merge(tree[r * 2 + 1], cur);
                r = r * 2;
            }
        }
        return (r ^ n);
    }
};

template<typename Item>
struct Pusher<Item, true> {
    void push(vector<Item>& tree, int ind, int l, int r) {
        tree[ind].push(tree[ind * 2], tree[ind * 2 + 1], l, r);
    }

    Item ask_on_segment(vector<Item>& tree, int n, int l, int r) {
        int vl = 0, vr = n - 1;
        int i = 1;
        Item result;
        while (vl != vr) {
            int m = (vl + vr) / 2;
            if (l > m) {
                push(tree, i, vl, vr);
                i = i * 2 + 1;
                vl = m + 1;
            } else if (r <= m) {
                push(tree, i, vl, vr);
                i = i * 2;
                vr = m;
            } else {
                break;
            }
        }
        if (l == vl && r == vr) {
            return tree[i];
        }
        push(tree, i, vl, vr);
        // left
        {
            int ind = i * 2;
            int L = vl, R = (vl + vr) / 2;
            while (l != L) {
                int m = (L + R) / 2;
                push(tree, ind, L, R);
                if (l <= m) {
                    result = tree_merge(tree[ind * 2 + 1], result);
                    ind *= 2;
                    R = m;
                } else {
                    ind = ind * 2 + 1;
                    L = m + 1;
                }
            }
            result = tree_merge(tree[ind], result);
        }
        // right
        {
            int ind = i * 2 + 1;
            int L = (vl + vr) / 2 + 1, R = vr;
            while (r != R) {
                int m = (L + R) / 2;
                push(tree, ind, L, R);
                if (r > m) {
                    result = tree_merge(result, tree[ind * 2]);
                    ind = ind * 2 + 1;
                    L = m + 1;
                } else {
                    ind = ind * 2;
                    R = m;
                }
            }
            result = tree_merge(result, tree[ind]);
        }
        return result;
    }

    void push_point(vector<Item>& tree, int n, int ind) {
        int l = 0, r = n - 1;
        int i = 1;
        while (l != r) {
            push(tree, i, l, r);
            int m = (l + r) / 2;
            if (ind <= m) {
                r = m;
                i *= 2;
            } else {
                l = m + 1;
                i = i * 2 + 1;
            }
        }
    }

    template<typename P>
    pair<int, Item> _lower_bound(vector<Item>& tree, int l, P p, Item cur, int i, int vl, int vr) {
        if (vl == vr) {
            if (p(tree_merge(cur, tree[i]))) {
                return {vl, tree[i]};
            } else {
                return {vl + 1, tree[i]};
            }
        }

        push(tree, i, vl, vr);
        int m = (vl + vr) / 2;
        if (l > m) {
            return _lower_bound(tree, l, p, cur, i * 2 + 1, m + 1, vr);
        } else if (l <= vl) {
            if (!p(tree_merge(cur, tree[i]))) {
                return {vr + 1, tree_merge(cur, tree[i])};
            }
            if (p(tree_merge(cur, tree[i * 2]))) {
                return _lower_bound(tree, l, p, cur, i * 2, vl, m);
            } else {
                return _lower_bound(tree, l, p, tree_merge(cur, tree[i * 2]), i * 2 + 1, m + 1, vr);
            }
        } else {
            auto [ind, it] = _lower_bound(tree, l, p, cur, i * 2, vl, m);
            if (ind <= m) return {ind, it};
            return _lower_bound(tree, l, p, it, i * 2 + 1, m + 1, vr);
        }
    }

    template<typename P>
    int lower_bound(vector<Item>& tree, int n, int l, P p) {
        Item cur;
        if (p(cur)) return l - 1;
        return _lower_bound(tree, l, p, cur, 1, 0, n - 1).first;
    }

    template<typename P>
    pair<int, Item> _lower_bound_rev(vector<Item>& tree, int r, P p, Item cur, int i, int vl, int vr) {
        if (vl == vr) {
            if (p(tree_merge(tree[i], cur))) {
                return {vl, tree[i]};
            } else {
                return {vl - 1, tree[i]};
            }
        }

        push(tree, i, vl, vr);
        int m = (vl + vr) / 2;
        if (r <= m) {
            return _lower_bound_rev(tree, r, p, cur, i * 2, vl, m);
        } else if (r >= vr) {
            if (!p(tree_merge(tree[i], cur))) {
                return {vl - 1, tree_merge(cur, tree[i])};
            }
            if (p(tree_merge(tree[i * 2 + 1], cur))) {
                return _lower_bound_rev(tree, r, p, cur, i * 2 + 1, m + 1, vr);
            } else {
                return _lower_bound_rev(tree, r, p, tree_merge(tree[i * 2 + 1], cur), i * 2, vl, m);
            }
        } else {
            auto [ind, it] = _lower_bound_rev(tree, r, p, cur, i * 2 + 1, m + 1, vr);
            if (ind > m) return {ind, it};
            return _lower_bound_rev(tree, r, p, it, i * 2, vl, m);
        }
    }

    template<typename P>
    int lower_bound_rev(vector<Item>& tree, int n, int r, P p) {
        Item cur;
        if (p(cur)) return r + 1;
        return _lower_bound_rev(tree, r, p, cur, 1, 0, n - 1).first;
    }
};

template<typename Item, bool lazy = false>
struct Segtree {
    vector<Item> tree;
    Pusher<Item, lazy> pusher;
    int n;
    int n0;

    Segtree(int n = 0) {
        build(n);
    }

    template<typename U>
    Segtree(const vector<U>& v) {
        build(v);
    }

    void build(int n) {
        this->n0 = n;
        while (n & (n - 1)) ++n;
        this->n = n;
        tree.assign(n * 2, {});
    }

    template<typename U>
    void build(const vector<U>& v) {
        build(v.size());
        for (int i = 0; i < v.size(); ++i) {
            tree[n | i].init(v[i], i);
        }
        build();
    }

    void build() {
        for (int i = n - 1; i >= 1; --i) {
            tree[i].update(tree[i * 2], tree[i * 2 + 1]);
        }
    }

    void push(int ind, int l, int r) {
        pusher.push(tree, ind, l, r);
    }

    template<typename T>
    void set(int ind, const T& t) {
        pusher.push_point(tree, n, ind);
        ind |= n;
        tree[ind].init(t, ind ^ n);
        ind >>= 1;
        while (ind) {
            tree[ind].update(tree[ind * 2], tree[ind * 2 + 1]);
            ind >>= 1;
        }
    }

    template<typename T>
    void update(int ind, const T& t) {
        pusher.push_point(tree, n, ind);
        ind |= n;
        tree[ind].update(t, ind ^ n);
        ind >>= 1;
        while (ind) {
            tree[ind].update(tree[ind * 2], tree[ind * 2 + 1]);
            ind >>= 1;
        }
    }

    Item& ith(int ind) {
        static_assert(!lazy, "don't use this method with lazy propagation, unless you're sure you need it");
        return tree[ind | n];
    }

    const Item& root() const {
        return tree[1];
    }

    Item ask(int l, int r) {
        l = max(l, 0);
        r = min(r, n - 1);
        if (l > r) return {};
        return pusher.ask_on_segment(tree, n, l, r);
    }

    template<typename T>
    void modify(int l, int r, const T& t) {
        static_assert(lazy, "lazy must be set to true to use this function");
        l = max(l, 0);
        r = min(r, n - 1);
        if (l > r) return;
        int vl = 0, vr = n - 1;
        int i = 1;
        while (vl != vr) {
            int m = (vl + vr) / 2;
            if (l > m) {
                push(i, vl, vr);
                i = i * 2 + 1;
                vl = m + 1;
            } else if (r <= m) {
                push(i, vl, vr);
                i = i * 2;
                vr = m;
            } else {
                break;
            }
        }
        if (l == vl && r == vr) {
            tree[i].modify(t, l, r);
        } else {
            push(i, vl, vr);
            // left
            {
                int ind = i * 2;
                int L = vl, R = (vl + vr) / 2;
                while (l != L) {
                    int m = (L + R) / 2;
                    push(ind, L, R);
                    if (l <= m) {
                        tree[ind * 2 + 1].modify(t, m + 1, R);
                        ind *= 2;
                        R = m;
                    } else {
                        ind = ind * 2 + 1;
                        L = m + 1;
                    }
                }
                tree[ind].modify(t, L, R);
                ind >>= 1;
                while (ind != i) {
                    tree[ind].update(tree[ind * 2], tree[ind * 2 + 1]);
                    ind >>= 1;
                }
            }
            // right
            {
                int ind = i * 2 + 1;
                int L = (vl + vr) / 2 + 1, R = vr;
                while (r != R) {
                    int m = (L + R) / 2;
                    push(ind, L, R);
                    if (r > m) {
                        tree[ind * 2].modify(t, L, m);
                        ind = ind * 2 + 1;
                        L = m + 1;
                    } else {
                        ind = ind * 2;
                        R = m;
                    }
                }
                tree[ind].modify(t, L, R);
                ind >>= 1;
                while (ind != i) {
                    tree[ind].update(tree[ind * 2], tree[ind * 2 + 1]);
                    ind >>= 1;
                }
            }
            tree[i].update(tree[i * 2], tree[i * 2 + 1]);
        }
        i >>= 1;
        while (i) {
            tree[i].update(tree[i * 2], tree[i * 2 + 1]);
            i >>= 1;
        }
    }

    // first index r such that p(tree.ask(l, r)) == true
    // if p() is true for empty item, return l-1
    // if p() is never true, returns n
    template<typename P>
    int lower_bound(int l, P p) {
        l = max(l, 0);
        if (l >= n0) return n0;
        return min(n0, pusher.lower_bound(tree, n, l, p));
    }

    // similarly to lower_bound, returns first (largest) l such that p(tree.ask(l, r)) == true
    template<typename P>
    int lower_bound_rev(int r, P p) {
        r = min(r, n0 - 1);
        if (r < 0) return -1;
        return pusher.lower_bound_rev(tree, n, r, p);
    }
};

}
using segtree::Segtree;

const int p = 74628364;
const int p2 = 48732684;
const int mod = 1e9 + 7;
const int mod2 = 998244353;
array<int, 200005> degp;
array<int, 200005> degp2;

struct Item {
    int ln = 0;
    int hsh = 0;
    int ihsh = 0;
    // int hsh2 = 0;
    // int ihsh2 = 0;

    template<typename T>
    void init(const T& t, int ind) {
        hsh = t;
        ihsh = t;
        // hsh2 = t;
        // ihsh2 = t;
        ln = 1;
    }

    void update(const Item& a, const Item& b) {
        ln = a.ln + b.ln;
        hsh = ((ll)degp[a.ln] * b.hsh + a.hsh) % mod;
        ihsh = ((ll)degp[b.ln] * a.ihsh + b.ihsh) % mod;
        // hsh2 = ((ll)degp2[a.ln] * b.hsh2 + a.hsh2) % mod2;
        // ihsh2 = ((ll)degp2[b.ln] * a.hsh2 + b.hsh2) % mod2;
    }

    //// similar to init, but more convenient for doing a[i] += x, implement only if needed
    // template<typename T>
    // void update(const T& t, int ind) {}

    //// apply here, save for children
    // template<typename T>
    // void modify(const T& m, int l, int r) {}

    // void push(Item& a, Item& b, int l, int r) {
    //     int m = (l + r) / 2;
    //     a.modify(mod, l, m);
    //     b.modify(mod, m + 1, r);
    //     // reset mod
    // }
};

OSTREAM(Item, ln, hsh, ihsh);

template<class Fun>
class y_combinator_result {
    Fun fun_;
public:
    template<class T>
    explicit y_combinator_result(T &&fun): fun_(std::forward<T>(fun)) {}

    template<class ...Args>
    decltype(auto) operator()(Args &&...args) {
        return fun_(std::ref(*this), std::forward<Args>(args)...);
    }
};
template<class Fun>
decltype(auto) y_combinator(Fun &&fun) {
    return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun));
}
// auto gcd = std::y_combinator([](auto gcd, int a, int b) -> int {
//     return b == 0 ? a : gcd(b, a % b);
// });

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int n;
    cin >> n;

    degp[0] = 1;
    for (int i = 1; i < n + 2; ++i)
        degp[i] = (ll)degp[i - 1] * p % mod;
    degp2[0] = 1;
    for (int i = 1; i < n + 2; ++i)
        degp2[i] = (ll)degp2[i - 1] * p2 % mod2;

    vector<int> p(n - 1);
    cin >> p;
    --p;
    p.insert(p.begin(), -1);

    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i)
        g[p[i]].pb(i);

    build_lca_sparse(g, 0);

    vector<int> tree_ind(n);
    vector<int> path_root(n);
    vector<int> tree_order;

    vector<int> sz(n, 1);

    y_combinator([&](auto dfs, int v) -> void {
        for (int k : g[v]) {
            dfs(k);
            sz[v] += sz[k];
        }
    })(0);

    y_combinator([&](auto dfs, int v, int rt) -> void {
        if (rt == -1) {
            rt = v;
        }
        tree_ind[v] = tree_order.size();
        tree_order.pb(v);
        path_root[v] = rt;

        for (int i = 1; i < g[v].size(); ++i)
            if (sz[g[v][i]] > sz[g[v][0]]) swap(g[v][i], g[v][0]);
        for (int i = 0; i < g[v].size(); ++i) {
            if (i == 0)
                dfs(g[v][i], rt);
            else
                dfs(g[v][i], -1);
        }
    })(0, -1);

    Segtree<Item, false> tree(n);

    vector<pair<int, int>> lr(n);
    cin >> lr;

    Mint ans = 1;
    for (auto [l, r] : lr)
        ans *= r - l + 1;

    vector<vector<int>> comp(n);
    for (int i = 0; i < n; ++i) {
        comp[i].pb(i);
    }

    vector<int> col(n);
    for (int i = 0; i < n; ++i) {
        col[i] = i;
        tree.set(tree_ind[i], i);
    }

    vector<vector<int>> up(20, vector<int>(n, -1));
    up[0] = p;
    for (int i = 1; i < up.size(); ++i) {
        for (int j = 0; j < n; ++j) {
            if (up[i - 1][j] != -1) {
                up[i][j] = up[i - 1][up[i - 1][j]];
            }
        }
    }

    auto go_up = [&](int v, int h) {
        assert(h >= 0);
        for (int i = 0; h != 0; ++i) {
            if ((h >> i) & 1) {
                h ^= (1 << i);
                v = up[i][v];
            }
        }
        return v;
    };

    auto un = [&](int u, int v) {
        if (u == v) return;
        if (comp[u].size() < comp[v].size())
            swap(u, v);

        for (int k : comp[v]) {
            comp[u].pb(k);
            col[k] = u;
            tree.set(tree_ind[k], u);
        }
        comp[v].clear();
        if (lr[u].second >= lr[u].first)
            ans /= lr[u].second - lr[u].first + 1;
        if (lr[v].second >= lr[v].first)
            ans /= lr[v].second - lr[v].first + 1;

        lr[u].first = max(lr[u].first, lr[v].first);
        lr[u].second = min(lr[u].second, lr[v].second);
        ans *= max(0, lr[u].second - lr[u].first + 1);
    };

    // auto get_path = [&](int u, int v) {
    //     int c = get_lca(u, v);
    //     vector<int> res;
    //     while (u != c) {
    //         res.pb(u);
    //         u = p[u];
    //     }
    //     res.pb(c);
    //     int s = res.size();
    //     while (v != c) {
    //         res.pb(v);
    //         v = p[v];
    //     }
    //     reverse(res.begin() + s, res.end());
    //     return res;
    // };

    auto get_hash = [&](int u, int v) {
        bool rev = false;
        if (lca_depth[u] < lca_depth[v]) {
            rev = true;
            swap(u, v);
        }
        Item it;
        // int u0 = u;
        while (true) {
            if (path_root[u] == path_root[v]) {
                show(tree_ind[v], tree_ind[u]);
                it = segtree::tree_merge(tree.ask(tree_ind[v], tree_ind[u]), it);
                break;
            }
            it = segtree::tree_merge(tree.ask(tree_ind[path_root[u]], tree_ind[u]), it);
            u = p[path_root[u]];
        }
        int res = rev ? it.ihsh : it.hsh;
        show(u0, v, rev, it);
        return res;
    };

    // auto go_down = [&](int a, int h, int to) {
    //     return go_up(to, dist(a, to) - h);
    // };

    auto un_same_rec = y_combinator([&](auto un_same_rec, int a, int b, int c, int d, int ln) -> void {
        if (ln == 0) {
            show(a, c);
            un(col[a], col[c]);
            return;
        }
        if (get_hash(a, b) == get_hash(c, d)) return;
        int abm = go_up(a, ln / 2);
        int cdm = go_up(c, ln / 2);
        un_same_rec(a, abm, c, cdm, ln / 2);
        un_same_rec(p[abm], b, p[cdm], d, ln - ln / 2 - 1);
    });

    auto un_same = [&](int a, int b, int c, int d) {
        show(col);
        show(a, b, c, d);
        un_same_rec(a, b, c, d, dist(a, b));
        // int len = dist(a, b);
        // while (a != b) {
        //     show(col);
        //     show(a, b, c, d);
        //     if (col[a] == col[c]) {
        //         int L = 0, R = len;
        //         while (R - L > 1) {
        //             int C = (L + R) / 2;
        //             if (get_hash(a, go_up(a, C)) == get_hash(c, go_up(c, C))) {
        //                 L = C;
        //             } else {
        //                 R = C;
        //             }
        //         }
        //         a = go_up(a, R);
        //         c = go_up(c, R);
        //         show(R);
        //         len -= R;
        //         if (a == b) break;
        //     }
        //     un(col[a], col[c]);
        //     a = p[a];
        //     c = p[c];
        //     --len;
        // }
        // un(col[b], col[d]);
    };

    auto un_opposite_rec = y_combinator([&](auto un_opposite_rec, int a, int b, int c, int d, int ln) -> void {
        if (ln == 0) {
            show(a, c);
            un(col[a], col[c]);
            return;
        }
        if (get_hash(a, b) == get_hash(c, d)) return;
        int abm = go_up(a, ln / 2);
        int cdm1 = go_up(d, ln - ln / 2 - 1);
        int cdm = p[cdm1];
        un_opposite_rec(a, abm, c, cdm, ln / 2);
        un_opposite_rec(p[abm], b, cdm1, d, ln - ln / 2 - 1);
    });

    auto un_opposite = [&](int a, int b, int c, int d) {
        un_opposite_rec(a, b, c, d, dist(a, b));
        // int len = dist(a, b);
        // while (a != b) {
        //     show(col);
        //     show(a, b, c, d);
        //     if (col[a] == col[c]) {
        //         int L = 0, R = len;
        //         while (R - L > 1) {
        //             int C = (L + R) / 2;
        //             if (get_hash(a, go_up(a, C)) == get_hash(c, go_down(c, C, d))) {
        //                 L = C;
        //             } else {
        //                 R = C;
        //             }
        //         }
        //         a = go_up(a, R);
        //         c = go_down(c, R, d);
        //         show(R);
        //         len -= R;
        //         if (a == b) break;
        //     }
        //     un(col[a], col[c]);
        //     a = p[a];
        //     c = go_down(c, 1, d);
        //     --len;
        // }
        // un(col[b], col[d]);
    };

    auto un_paths = [&](int a, int b, int c, int d) {
        show(a, b, c, d);
        assert(get_lca(a, b) == a || get_lca(a, b) == b);
        assert(get_lca(c, d) == c || get_lca(c, d) == d);
        assert(dist(a, b) == dist(c, d));

        if (a == b) {
            un(col[a], col[c]);
            return;
        }

        if (lca_depth[a] < lca_depth[b]) {
            swap(a, b);
            swap(c, d);
        }

        if (lca_depth[c] > lca_depth[d]) {
            un_same(a, b, c, d);
        } else {
            un_opposite(a, b, c, d);
        }
    };

    int m;
    cin >> m;
    while (m--) {
        shows;
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;

        show(col);


        int len = dist(a, b);
        int len1 = dist(a, get_lca(a, b));
        int len2 = dist(c, get_lca(c, d));
        if (len1 > len2) {
            swap(a, c);
            swap(b, d);
            swap(len1, len2);
        }
        show(a, b, c, d);

        int ab1 = get_lca(a, b);
        int ab2 = go_up(b, len - len2);
        int cd1 = go_up(c, len1);
        int cd2 = get_lca(c, d);

        un_paths(a, ab1, c, cd1);
        un_paths(ab1, ab2, cd1, cd2);
        un_paths(ab2, b, cd2, d);

        show(col);

        cout << ans << '\n';
    }

    return 0;
}
