#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
#include <numeric>

#define endl '\n'
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define int long long
using namespace std;

void solve();

mt19937 rnd(2007);

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    swap(rng, rnd);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}


const int mod = (int) 1e9 + 7;

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res *= a;
            res %= mod;
        }
        a *= a;
        a %= mod;
        n >>= 1;
    }
    return res;
}

int inverse(int x) {
    return binpow(x, mod - 2);
}

struct interval {
    int l;
    int r;
};

interval intersect(interval a, interval b) {
    interval res = {max(a.l, b.l), min(a.r, b.r)};
    if (res.l > res.r) {
        res.l = 1;
        res.r = 0;
    }
    return res;
}

int length(interval a) {
    return a.r - a.l + 1;
}


struct fenwick {
    vector<int> t;
    const static int offset = 7;

    fenwick(int n) {
        t.resize(n + 40);
    }

    void add(int i, int val) {
        val %= mod;
        for (i += offset; i < len(t); i += i & -i) {
            t[i] += val;
            if (t[i] >= mod) {
                t[i] -= mod;
            }
        }
    }

    int sum(int r) {
        int ans = 0;
        for (r += offset; r > 0; r -= r & -r) {
            ans += t[r];
        }
        return ans % mod;
    }
};

struct segment_add_get {
    fenwick f;
    int n;

    segment_add_get(int n_) : f(fenwick(n_ + 1)), n(n_) {}

    void add(int l, int r, int val) {
        f.add(l, val);
        f.add(r + 1, mod - val);
    }

    int get(int id) {
        return f.sum(id);
    }
};

struct tree_path_difference {
    const static int K = 20;
    vector<int> p, lb, rb;
    vector<int> depth;
    vector<int> vals;
    vector<vector<int>> up;
    vector<int> wh;
    vector<int> deepest;
    int n;
    vector<int> lg;

    segment_add_get h, h_;
    vector<int> pw, pw_;
    const int B = 2e5;

    vector<int> euler;
    vector<int> wh_lad;
    vector<int> st;

    void clean_st() {
        if (st.empty()) {
            return;
        }
        reverse(all(st));
        int cnt = len(st);
        forn (qwe, cnt * 2 + 1) {
            if (p[st.back()] == -1) {
                break;
            }
            st.push_back(p[st.back()]);
        }
        int delta = len(st) - cnt;
        reverse(all(st));
        forn (i, len(st)) {
            euler.push_back(st[i]);
            if (i >= delta) {
                wh_lad[st[i]] = len(euler) - 1;
            }
        }
        st.clear();
    }

    void dfs(vector<vector<int>> &g, int v, int &timer, int prv = -1) {
        if (prv != -1) {
            depth[v] = depth[prv] + 1;
        }
        if (!st.empty() && st.back() != prv) {
            clean_st();
        }
        st.push_back(v);

        wh[v] = timer;
        lb[v] = timer;
        timer++;
        for (auto u: g[v]) {
            dfs(g, u, timer, v);
        }
        rb[v] = timer - 1;
    }

    void dfs_deepest(vector<vector<int>> &g, int v) {
        vector<pair<int, int>> ord;
        for (auto u: g[v]) {
            dfs_deepest(g, u);
            deepest[v] = max(deepest[v], deepest[u] + 1);
        }
        for (auto u: g[v]) {
            ord.push_back({deepest[u], u});
        }
        sort(all(ord));
        reverse(all(ord));
        g[v] = {};
        for (auto u: ord) {
            g[v].push_back(u.second);
        }
    }

    tree_path_difference(vector<int> p_) : p(p_), n(len(p_)), h(len(p_)), h_(len(p_)) {

        // lg
        lg.resize(n * 2);
        lg[0] = -1;
        for (int i = 1; i < len(lg); ++i) {
            lg[i] = lg[i / 2] + 1;
        }
        wh_lad.resize(n, -1);

        deepest.resize(n, 1);

        // build borders
        wh.resize(n);
        vector<vector<int>> g(n);
        lb.resize(n);
        rb.resize(n);
        for (int i = 1; i < n; i++) {
            g[p[i]].push_back(i);
        }
        depth.resize(n);

        dfs_deepest(g, 0);
        int timer = 0;
        dfs(g, 0, timer);
        if (!st.empty()) clean_st();

        // up init
        up.resize(K, vector<int>(n));
        up[0] = p;
        up[0][0] = 0;
        for (int l = 1; l < K; l++) {
            forn (i, n) {
                up[l][i] = up[l - 1][up[l - 1][i]];
            }
        }
        // build powers
        pw.push_back(1);
        pw_.push_back(1);
        int B_ = inverse(B);
        for (int i = 0; i <= n * 2; i++) {
            pw.push_back(pw.back() * B % mod);
            pw_.push_back(pw_.back() * B_ % mod);

        }
        // build hashes
        vals.resize(n);
        forn (i, n) {
            vals[i] = i + 1;
        }
        forn (i, n) {
            h.add(lb[i], rb[i], vals[i] * pw[depth[i]] % mod);
            h_.add(lb[i], rb[i], vals[i] * pw_[depth[i]] % mod);
        }
    }

    int go_up(int v, int hgt) {
        if (hgt == 0) {
            return v;
        }
        int fst = lg[hgt];
        hgt -= 1 << fst;
        v = up[fst][v];
        return euler[wh_lad[v] - hgt];
    }

    int lca(int v, int u) {
        if (depth[v] < depth[u]) {
            swap(v, u);
        }
        // depth[v] > depth[u]
        v = go_up(v, depth[v] - depth[u]);
        // depth[v] == depth[u]
        if (v == u) {
            return v;
        }
        for (int l = K - 1; l >= 0; l--) {
            if (up[l][v] != up[l][u]) {
                v = up[l][v];
                u = up[l][u];
            }
        }
        return up[0][v];
    }

    int length(int v, int u) {
        int lc = lca(v, u);
        return depth[v] + depth[u] - depth[lc] * 2;
    }

    int get_hash_up(int v, int cnt) {
        int v0 = go_up(v, cnt - 1);
        int h0 = 0;
        if (v0 != 0) {
            h0 = h.get(wh[p[v0]]);
        }
        int ans = h.get(wh[v]) - h0;
        ans %= mod;
        ans += mod;
        ans %= mod;
        ans *= pw_[depth[v0]];
        ans %= mod;
        return ans;
    }

    int get_hash_up_(int v, int cnt) {
        int v0 = go_up(v, cnt - 1);
        int h0 = 0;
        if (v0 != 0) {
            h0 = h_.get(wh[p[v0]]);
        }
        int ans = h_.get(wh[v]) - h0;
        ans %= mod;
        ans += mod;
        ans %= mod;
        return ans * pw[depth[v]] % mod;
    }


    int get_hash(int v, int u, int cnt, int lc, int h1, int lng) {
        if (depth[v] - depth[lc] + 1 >= cnt) {
            return get_hash_up(v, cnt);
        }

        int v0 = go_up(u, lng + 1 - cnt);
        int cnt0 = depth[v0] - depth[lc];
        return (h1 * pw[cnt0] % mod + get_hash_up_(v0, cnt0)) % mod;
    }

    void modify(int id, int nval) {
        h.add(lb[id], rb[id], (mod - vals[id] + nval) * pw[depth[id]] % mod);
        h_.add(lb[id], rb[id], (mod - vals[id] + nval) * pw_[depth[id]] % mod);
        vals[id] = nval;
    }

    int go(int v, int u, int id) {
        int lc = lca(v, u);

        int depth_delta = depth[v] - depth[lc];
        if (depth_delta >= id) {
            return go_up(v, id);
        }
        return go_up(u, length(v, u) - id);
    }

    // n calls -> time = log^2
    pair<int, int> get_first_diff(int v1, int u1, int v2, int u2) {
        int cnt = length(v1, u1) + 1;
        int l = 0, r = cnt + 1;
        int lc1 = lca(v1, u1);
        int h1 = get_hash_up(v1, depth[v1] - depth[lc1] + 1);
        int lng1 = length(v1, u1);
        int lc2 = lca(v2, u2);
        int h2 = get_hash_up(v2, depth[v2] - depth[lc2] + 1);
        int lng2 = length(v2, u2);


        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get_hash(v1, u1, m, lc1, h1, lng1) == get_hash(v2, u2, m, lc2, h2, lng2)) {
                l = m;
            } else {
                r = m;
            }
        }
        if (l == cnt) {
            return {-1, -1};
        }
        pair<int, int> res = {go(v1, u1, l), go(v2, u2, l)};
        return res;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    forn (i, n - 1) cin >> p[i + 1];
    forn (i, n) p[i]--;
    vector<interval> prices(n + 1);
    forn (i, n) cin >> prices[i + 1].l >> prices[i + 1].r;

    int ans = 1;
    forn (i, n) {
        ans *= length(prices[i + 1]);
        ans %= mod;
    }

    vector<vector<int>> sets(n + 1);
    vector<int> set_ids(n);
    forn (i, n) {
        sets[i + 1] = {i};
        set_ids[i] = i + 1;
    }
    tree_path_difference diff(p);


    int m;
    cin >> m;
    int cnt = 0;
    forn (qwe, m) {
        int v1, u1, v2, u2;
        cin >> v1 >> u1 >> v2 >> u2;
        v1--;
        u1--;
        v2--;
        u2--;
        auto [d1, d2] = diff.get_first_diff(v1, u1, v2, u2);
        while (d1 != -1) {
            cnt++;
            auto id1 = set_ids[d1];
            auto id2 = set_ids[d2];

            ans *= inverse(length(prices[id1]));
            ans %= mod;
            ans *= inverse(length(prices[id2]));
            ans %= mod;

            if (len(sets[id1]) < len(sets[id2])) {
                swap(id1, id2);
            }
            // len(sets[id1]) > len(sets[id2])
            for (auto el: sets[id2]) {
                sets[id1].push_back(el);
                set_ids[el] = id1;
                diff.modify(el, id1);
            }
            sets[id2].clear();
            prices[id1] = intersect(prices[id1], prices[id2]);
            ans *= length(prices[id1]);
            ans %= mod;

            // Unpack
            auto ret = diff.get_first_diff(v1, u1, v2, u2);
            d1 = ret.first;
            d2 = ret.second;
        }
        cout << ans << endl;
    }
}