#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int BASE = 1791791, MOD = 1e9 + 7, MAXN = 2e5 + 100;
int power[MAXN];

array<int, 3> op(const array<int, 3> &a, const array<int, 3> &b) {
    array<int, 3> res;
    res[2] = a[2] + b[2];
    res[0] = (a[0] * power[b[2]] + b[0]) % MOD;
    res[1] = (a[1] + power[a[2]] * b[1]) % MOD;
    return res;
}

array<int, 3> tree[MAXN * 2];

void pull(int v) {
    tree[v] = op(tree[2 * v], tree[2 * v + 1]);
}

void build() {
    for (int i = 0; i < MAXN; ++i) {
        tree[i + MAXN] = {0, 0, 1};
    }
    for (int i = MAXN - 1; i > 0; --i) {
        pull(i);
    }
}

void update(int ind, int val) {
    ind += MAXN;
    tree[ind] = {val, val, 1};
    while (ind / 2 > 0) {
        ind /= 2;
        pull(ind);
    }
}

array<int, 2> get(int l, int r) {
    l += MAXN; r += MAXN - 1;
    array<int, 3> lft = {0, 0, 0}, rgh = {0, 0, 0};
    while (l <= r) {
        if (l % 2 == 1) {
            lft = op(lft, tree[l]);
        }
        if (r % 2 == 0) {
            rgh = op(tree[r], rgh);
        }
        l = (l + 1) / 2;
        r = (r - 1) / 2;
    }
    auto res = op(lft, rgh);
    return {res[0], res[1]};
}

int p[MAXN];
vector<int> g[MAXN];
int tin[MAXN], tout[MAXN], tim = 0;

void dfs(int v) {
    tin[v] = tim++;
    for (int u : g[v]) {
        dfs(u);
    }
    tout[v] = tim++;
}

bool is_anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

void build_path(int u, int v, vector<int> &arr) {
    arr.clear();
    while (!is_anc(u, v)) {
        arr.push_back(u);
        u = p[u];
    }
    arr.push_back(u);
    int cur = arr.size();
    while (v != u) {
        arr.push_back(v);
        v = p[v];
    }
    reverse(arr.begin() + cur, arr.end());
}

vector<int> in[MAXN];
int col[MAXN];
int ans = 1;
int l[MAXN], r[MAXN];

int inv(int x) {
    int res = 1, n = MOD - 2;
    while (n) {
        if (n % 2 == 0) {
            x = (x * x) % MOD;
            n /= 2;
        } else {
            res = (res * x) % MOD;
            n--;
        }
    }
    return res;
}

bool f = true;

void mrg(int i, int j) {
    if (i == j) return;
    if (ans == 0) return;
    ans = (ans * inv(r[i] - l[i])) % MOD;
    ans = (ans * inv(r[j] - l[j])) % MOD;
    if (in[i].size() < in[j].size()) swap(i, j);
    l[i] = max(l[i], l[j]);
    r[i] = min(r[i], r[j]);
    if (l[i] >= r[i]) {
        ans = 0;
        return;
    }
    ans = (ans * (r[i] - l[i])) % MOD;
    for (int v : in[j]) {
        in[i].push_back(v);
        if (f) {
            update(v, i);
        }
        col[v] = i;
    }
}

main() {
    power[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        power[i] = (power[i - 1] * BASE) % MOD;
    }
    build();

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        f &= (p[i] == i);
        p[i]--;
        g[p[i]].push_back(i);
    }
    if (f) {
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
            l[i]--;
            col[i] = i;
            update(i, i);
            in[i].push_back(i);
            ans = (ans * (r[i] - l[i])) % MOD;
        }
        int quer;
        cin >> quer;
        while (quer--) {
            if (ans == 0) {
                cout << 0 << "\n";
                continue;
            }
            int l1, r1, l2, r2;
            cin >> l1 >> r1 >> l2 >> r2;
            l1--; r1--; l2--; r2--;
            if (r1 < l1) {
                swap(l1, r1);
                swap(l2, r2);
            }
            while (l1 <= r1) {
                int l = 0, r = r1 - l1 + 2;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    int hsh1 = get(l1, l1 + m)[0];
                    int hsh2;
                    if (l2 <= r2) {
                        hsh2 = get(l2, l2 + m)[0];
                    } else {
                        hsh2 = get(l2 - m + 1, l2 + 1)[1];
                    }
                    if (hsh1 == hsh2) {
                        l = m;
                    } else {
                        r = m;
                    }
                }
                if (l == r1 - l1 + 1) break;
                l1 += l;
                if (l2 <= r2) {
                    l2 += l;
                } else {
                    l2 -= l;
                }
                mrg(col[l1], col[l2]);
                l1++;
                if (l2 <= r2) {
                    l2++;
                } else {
                    l2--;
                }
            }
            cout << ans << "\n";
        }
        return 0;
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
        col[i] = i;
        in[i].push_back(i);
        ans = (ans * (r[i] - l[i])) % MOD;
    }
    vector<int> a, b;
    int m;
    cin >> m;
    while (m--) {
        if (ans == 0) {
            cout << 0 << "\n";
            continue;
        }
        int u, v;
        cin >> u >> v;
        u--; v--;
        build_path(u, v, a);
        cin >> u >> v;
        u--; v--;
        build_path(u, v, b);
        for (int i = 0; i < (int)a.size(); ++i) {
            mrg(col[a[i]], col[b[i]]);
        }
        cout << ans << "\n";
    }
    return 0;
}
