#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define  all(v) (v).begin(),(v).end()
#define sz(v) ((int)(v).size())

#define int ll

const int MOD = 1e9 + 7;

int len(pair<int, int> a) {
    if (a.second < a.first) {
        return 0;
    }
    return (a.second - a.first + 1) % MOD;
}

int mul(int a, int b) {
    return (ll) a * b % MOD;
}

int powmod(int a, int b) {
    int ans = 1;
    while (b) {
        if (b & 1) {
            ans = mul(ans, a);
        }
        a = mul(a, a);
        b >>= 1;
    }
    return ans;
}

int inv(int a) {
    return powmod(a, MOD - 2);
}

struct DSU {
    int n;
    vector<int> pa, ra;
    vector<pair<int, int>> segs;
    int ans;

    DSU(vector<pair<int, int>> segs) : segs(segs) {
        n = (int) segs.size();
        pa.resize(n);
        ra.resize(n);
        iota(all(pa), 0);
        ans = 1;
        for (int i = 0; i < n; ++i) {
            ans = mul(ans, len(segs[i]));
        }
    }

    int get(int a) {
        if (pa[a] == a) {
            return a;
        }
        return pa[a] = get(pa[a]);
    }

    void merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }
        if (ra[b] > ra[a]) {
            swap(a, b);
        }
        ans = mul(ans, inv(len(segs[a])));
        ans = mul(ans, inv(len(segs[b])));
        segs[a].first = max(segs[a].first, segs[b].first);
        segs[a].second = min(segs[a].second, segs[b].second);
        ans = mul(ans, len(segs[a]));
        pa[b] = a;
        ra[a] += ra[b];
    }
};

const int LOG = 20;

vector<vector<int>> ch;
vector<int> pa;
vector<int> d;
vector<vector<int>> up;
vector<int> tin, tout;
int cur_time = 0;

void dfs(int v, int p) {
    tin[v] = cur_time++;
    up[v].resize(LOG);
    up[v][0] = p;
    for (int i = 1; i < LOG; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    d[v] = d[p] + 1;
    for (int u : ch[v]) {
        dfs(u, v);
    }
    tout[v] = cur_time++;
}

int goup(int v, int k) {
    for (int i = 0; i < LOG; ++i) {
        if (k & (1 << i)) {
            v = up[v][i];
        }
    }
    return v;
}

int mv(int a, int b) {
    if (tin[a] <= tin[b] && tout[b] <= tout[a]) {
        return goup(b, d[b] - d[a] - 1);
    }
    return pa[a];
}

void solve() {
    int n;
    cin >> n;
    ch.resize(n);
    pa.assign(n, -1);
    tin.resize(n);
    tout.resize(n);
    up.resize(n);
    d.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        ch[p].push_back(i);
        pa[i] = p;
    }
    dfs(0, 0);
    vector<pair<int, int>> segs(n);
    for (int i = 0; i < n; ++i) {
        cin >> segs[i].first;
        cin >> segs[i].second;
    }
    DSU dsu(segs);
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        do {
            dsu.merge(a, c);
            if (a != b) {
                a = mv(a, b);
                c = mv(c, d);
            }
        } while (a != b);
        assert(c == d);
        dsu.merge(a, c);
        cout << dsu.ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
