#include "testlib.h"
#include "helper.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ll long long

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        return stoll(params[name]);
    } else {
        return def;
    }
}

const int MAXT = 40'000;
const int MAXN = 200'000;
const int MAXM = 200'000;
const int MAXC = (1 << 30) - 1;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }
    int t = get("t", MAXT);
    int N = get("N", MAXN);
    int ok = get("ok", 2);
    int distw = get("distw", 1);
    int maxc = get("maxc", MAXC);
    vector<int> n = rnd.partition(t, N, 1);
    cout << t << "\n";
    for (int i = 0; i < t; i++) {
        cout << n[i] << " " << n[i] << "\n";
        int dist = rnd.wnext(1, n[i], distw);
        int s = rnd.next(0, n[i] - 1);
        int t = (s + dist) % n[i];
        Graph g(n[i]);
        if (ok == 2) {
            map<pair<int, int>, int> e;
            for (int j = s; j != t; j = (j + 1) % n[i]) {
                e[{j, (j + 1) % n[i]}] = 1;
            }
            int cnt1 = 0, cnt2 = 0;
            int xor1 = 0, xor2 = 0;
            for (int j = 0; j < n[i]; j++) {
                int w = 0;
                if (e.find({j, (j + 1) % n[i]}) != e.end()) {
                    ++cnt1;
                    if (cnt1 == e.size()) {
                        w = xor1;
                    } else {
                        w = rnd.next(0, maxc);
                    }
                    xor1 ^= w;
                } else {
                    cnt2++;
                    if (cnt2 == n[i] - e.size()) {
                        w = xor2;
                    } else {
                        w = rnd.next(0, maxc);
                    }
                    xor2 ^= w;
                }
                g.AddEdge(j, (j + 1) % n[i], w);
            }
        } else if (ok == 1) {
            int xor1 = 0;
            int cnt1 = 0;
            for (int j = 0; j < n[i]; j++) {
                int w = 0;
                ++cnt1;
                if (cnt1 == n[i]) {
                    w = xor1;
                } else {
                    w = rnd.next(0, maxc);
                }
                xor1 ^= w;
                g.AddEdge(j, (j + 1) % n[i], w);
            }
        } else {
            for (int j = 0; j < n[i]; j++) {
                int w = rnd.next(0, maxc);
                g.AddEdge(j, (j + 1) % n[i], w);
            }
        }
        g.Print(false);
        cout << s + 1 << " " << t + 1 << "\n";
    }
    return 0;
}
