#include "testlib.h"
#include "helper.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ll long long

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        return stoll(params[name]);
    } else {
        return def;
    }
}

const int MAXT = 40'000;
const int MAXN = 200'000;
const int MAXM = 200'000;
const int MAXC = (1 << 30) - 1;

void dfs(int v, vector<vector<int>> &g, vector<bool> &usd, vector<int> &b) {
    usd[v] = true;
    b.pb(v);
    for (auto &to : g[v]) {
        if (!usd[to]) dfs(to, g, usd, b);
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }
    int t = get("t", MAXT);
    int N = get("N", MAXN);
    int M = get("M", MAXM);
    int maxc = get("maxc", MAXC);
    cout << t << "\n";
    vector<int> n = rnd.partition(t, N, 1);
    vector<int> m = rnd.partition(t, M, 1);
    for (int i = 0; i < t; i++) {
        cout << n[i] << " " << m[i] << "\n";
        for (int j = 0; j < m[i]; j++) {
            int v = rnd.next(1, n[i]);
            int u = rnd.next(1, n[i]);
            int w = rnd.next(0, maxc);
            cout << v << " " << u << " " << w << "\n";
        }
        int s = rnd.next(1, n[i]), t = rnd.next(1, n[i]);
        cout << s << " " << t << "\n";
    }
    return 0;
}

