#include "testlib.h"
#include "helper.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ll long long

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        return stoll(params[name]);
    } else {
        return def;
    }
}

const int MAXT = 40'000;
const int MAXN = 200'000;
const int MAXM = 200'000;
const int MAXC = (1 << 30) - 1;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }
    int n = get("N", MAXN);
    int m = get("M", MAXM);
    int ok = get("ok", 1);
    int maxc = get("maxc", MAXC);
    cout << 1 << "\n";
    for (int tc = 0; tc < 1; tc++) {
        cout << n << " " << m << "\n";
        int s = rnd.next(0, n - 1);
        int t = rnd.next(0, n - 1);
        Graph g(n);
        vector<int> a(n);
        for (int i = 0; i < n; i++) a[i] = rnd.next(0, maxc);
        a[s] = a[t] = 0;
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                g.AddEdge(i, j, a[i] ^ a[j]);
                cnt++;
            }
        }
        while (m - cnt > 0) {
            int v = rnd.next(0, n - 1);
            int u = rnd.next(0, n - 1);
            g.AddEdge(u, v, a[v] ^ a[u]);
            cnt++;
        }
        if (!ok) {
            g.e[rnd.next(0, m - 1)].w = rnd.next(0, maxc);
        }
        g.Print();
        cout << s + 1 << " " << t + 1 << "\n";
    }
    return 0;
}
