#include "testlib.h"
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ll long long

struct Edge {
    int u = 0, v = 0, w = 0;
    Edge() {}
    Edge(int u_, int v_, int w_) : u(u_), v(v_), w(w_) {}

    void Print(bool ok = false) {
        int add = 0;
        if (!ok) add = 1;
        cout << u + add << " " << v + add << " " << w << "\n";
    }
};

struct Graph {
    int n = 0;
    vector<Edge> e;

    Graph() {}
    Graph(int n_) : n(n_) {}

    void AddEdge(int u, int v, int w, bool ok = false) {
        e.pb(u, v, w);
    }

    void Print(bool shuffled = true) {
        auto e1 = e;
        if (shuffled) {
            shuffle(e1.begin(), e1.end());
        }
        for (auto &c : e1) {
            c.Print();
        }
    }
};

vector<int> randomSet(int n, int k) {
    vector<int> a(n);
    for (int j = 0; j < n; j++) {
        a[j] = j;
    }
    shuffle(a.begin(), a.end());
    while (a.size() > k) {
        a.pop_back();
    }
    sort(all(a));
    return a;
}
