#include "testlib.h"
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXT = 40'000;
const int MAXN = 200'000;
const int MAXM = 200'000;
const int MAXC = (1 << 30) - 1;

const int maxn[7] = {MAXN, MAXN, MAXN, MAXN, 1000, MAXN, MAXN};
const int maxm[7] = {MAXM, MAXM, MAXM, MAXM, 1000, MAXM, MAXM};
const int maxc[7] = {MAXC, MAXC, 1, MAXC, 1023, 1, MAXC};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int t = inf.readInt(1, MAXT, "t");
    int group = atoi(validator.group().c_str());
    inf.readEoln();
    int sum_n = 0;
    int sum_m = 0;
    for (int i = 1; i <= t; i++) {
        setTestCase(i);
        int n = inf.readInt(1, maxn[group], "n");
        inf.readSpace();
        sum_n += n;
        int m = inf.readInt(1, maxm[group], "m");
        sum_m += m;
        if (group == 1) {
            ensuref(n == m, "n must be equal to m");
        }
        inf.readEoln();
        ensuref(sum_n <= maxn[group], "sum of n must be at most %d", maxn[group]);
        ensuref(sum_m <= maxm[group], "sum of m must be at most %d", maxm[group]);
        for (int j = 1; j <= m; j++) {
            int u = inf.readInt(1, n, "u_i");
            inf.readSpace();
            int v = inf.readInt(1, n, "v_i");
            inf.readSpace();
            int w = inf.readInt(0, maxc[group], "w_i");
            inf.readEoln();
            if (group == 1) {
                if (j < n) {
                    ensuref(u == j && v == j + 1, "%d-th edge is incorrect: (%d, %d)", j, u, v);
                }
                if (j == n) {
                    ensuref(u == n && v == 1, "%d-th edge is incorrect: (%d, %d)", j, u, v);
                }
            }
            if (group == 2 || group == 3) {
                ensuref(u < v, "%d-th edge is incorrect: (%d, %d)", j, u, v);
            }
        }
        int s = inf.readInt(1, n, "a");
        inf.readSpace();
        int t = inf.readInt(1, n, "b");
        inf.readEoln();
    }
    inf.readEof();
    return 0;
}
