#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ll long long

void dfs(int v, vector<vector<pair<int, int>>> &g, vector<bool> &usd) {
    usd[v] = true;
    for (auto &to: g[v]) {
        if (!usd[to.fi]) {
            dfs(to.fi, g, usd);
        }
    }
}

void check_all(int v, int &ans, vector<vector<pair<int, int>>> &g, int cur, int t, vector<bool> &fromT) {
    if (!fromT[v]) {
        return;
    }
    if (v == t) {
        ans ^= cur;
        return;
    }
    for (auto &e : g[v]) {
        check_all(e.first, ans, g, cur ^ e.second, t, fromT);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<vector<pair<int, int>>> gr(n);
    while (m--) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].pb(u, w);
        gr[u].pb(v, w);
    }
    int s, t;
    cin >> s >> t;
    s--;
    t--;
    vector<bool> fromT(n);
    dfs(t, gr, fromT);
    if (!fromT[s]) {
        cout << 0 << "\n";
        return;
    }
    int ans = 0;
    check_all(s, ans, g, 0, t, fromT);
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
