#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ll long long

void dfs(int v, vector<vector<pair<int, int>>> &g, vector<bool> &used, vector<int> &sum, vector<int> &par) {
    used[v] = true;
    for (auto &from : g[v]) {
        if (!used[from.first]) {
            dfs(from.first, g, used, sum, par);
        }
        sum[v] ^= sum[from.first];
        sum[v] ^= (from.second * par[from.first]);
        par[v] ^= par[from.first];
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> sum(n);
    vector<int> par(n);
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[b].pb(a, c);
    }
    int s, t;
    cin >> s >> t;
    s--; t--;
    par[s] = 1;
    vector<bool> used(n);
    used[s] = true;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, g, used, sum, par);
        }
    }
    cout << sum[t] << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
