#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a) for (auto& i : a) cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T1, typename T2> 
inline void chkmin(T1& x, const T2& y) {
    if (y < x) x = y;
}

template<typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y) x = y;
}

const int LOG = 30;
const int N = 5e5 + 10;

int n, m;
vector<pair<int, int>> g[N];
vector<pair<int, int>> rg[N];
int a, b;

int order[N];
int top;
bool used[N];
int rorder[N];

void dfsOrder(int v) {
    used[v] = true;
    for (auto [to, w] : g[v]) {
        if (!used[to]) {
            dfsOrder(to);
        }
    }
    rorder[v] = top;
    order[top++] = v;
}

bool usedA[N];
bool usedB[N];

void bfs(vector<pair<int, int>>* g, bool* used, int from) {
    fill(used, used + n, false);
    used[from] = true;
    queue<int> q;
    q.push(from);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [to, w] : g[v]) {
            if (used[to]) continue;
            used[to] = true;
            q.push(to);
        }
    }
}

void removeUnusedEdges() {
    bfs(g, usedA, a);
    bfs(rg, usedB, b);
    vector<array<int, 3>> edges;
    for (int v = 0; v < n; ++v) {
        for (auto [to, w] : g[v]) {
            if (usedA[v] && usedB[to]) {
                edges.push_back({v, to, w});
            }
        }
    }
    fill(g, g + n, vector<pair<int, int>>());
    fill(rg, rg + n, vector<pair<int, int>>());
    for (auto [from, to, w] : edges) {
        g[from].push_back({to, w});
        rg[to].push_back({from, w});
    }
}

int dp[LOG][N];
int rdp[LOG][N];

void build(int* dp, int from, int bit, vector<pair<int, int>>* g) {
    fill(dp, dp + n, -2);
    queue<int> q;
    q.push(from);
    dp[from] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [to, w] : g[v]) {
            int val = (w >> bit) & 1;
            if (dp[to] == -1) continue;
            if (dp[v] == -1) {
                dp[to] = -1;
                q.push(to);
            } else {
                if (dp[to] == -2) {
                    dp[to] = dp[v] ^ val;
                    q.push(to);
                } else {
                    if (dp[to] != (dp[v] ^ val)) {
                        dp[to] = -1;
                        q.push(to);
                    }
                }
            }
        }
    }
}

void build() {
    top = 0;
    fill(used, used + n, false);
    dfsOrder(a);
    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            dfsOrder(v);
        }
    }
    for (int bit = 0; bit < LOG; ++bit) {
        build(dp[bit], a, bit, g);
        build(rdp[bit], b, bit, rg);
    }
}

int calcSame(int from, int to1, int bit) {
    if (from == a) {
        return dp[bit][to1];
    } else if (to1 == b) {
        return rdp[bit][from];
    } else {
        throw;
    }
}

bool checkRemove(int from, int to, int w) {
    for (int bit = 0; bit < LOG; ++bit) {
        int A = calcSame(a, to, bit);
        int B = calcSame(from, b, bit);
        if (A == -1 || B == -1) {
            return false;
        }
        int C = ((w >> bit) & 1);
        assert(C != -1);
        if ((A ^ B ^ C) != 0) {
            return false;
        }
        if (C != ((w >> bit) & 1)) {
            return false;
        }
    }
    return true;
}

bool removeBackEdges() {
    for (int pos = n - 1; pos >= 0; --pos) {
        int from = order[pos];
        for (int i = 0; i < (int)g[from].size(); ++i) {
            int to = g[from][i].first;
            if (rorder[to] < pos) {
                continue;
            }
            if (!checkRemove(to, from, g[from][i].second)) {
                return false;
            }
        }
    }
    return true;
}

int total_xor[N];
int parity_cnt[N];

int ans;

int calcDp(int bit) {
    fill(total_xor, total_xor + n, 0);
    fill(parity_cnt, parity_cnt + n, 0);
    parity_cnt[a] = 1;
    for (int i = n - 1; i >= 0; --i) {
        int v = order[i];
        for (auto [to, w] : g[v]) {
            if (rorder[to] >= rorder[v]) continue;
            int val = (w >> bit) & 1;
            parity_cnt[to] ^= parity_cnt[v];
            total_xor[to] ^= total_xor[v] ^ (parity_cnt[v] * val);
        }
    }
    return total_xor[b];
}

void calcDp() {
    ans = 0;
    for (int bit = 0; bit < LOG; ++bit) {
        if (calcDp(bit)) {
            ans |= (1 << bit);
        }
    }
}

void solve() {
    cin >> n >> m;
    fill(g, g + n, vector<pair<int, int>>());
    fill(rg, rg + n, vector<pair<int, int>>());
    for (int i = 0; i < m; ++i) {
        int from, to, w;
        cin >> from >> to >> w;
        --from;
        --to;
        g[from].push_back({to, w});
        rg[to].push_back({from, w});
    }
    cin >> a >> b;
    --a;
    --b;
    removeUnusedEdges();
    build();
    if (!removeBackEdges()) {
        cout << "-1\n";
        return;
    }
    calcDp();
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout.flush();
    }
    return 0;
}
