#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 5e5 + 100;
vector<array<int, 2>> g[MAXN];
int used[MAXN], d[MAXN];

void col(int v) {
    d[v] = -1;
    for (auto ed : g[v]) {
        int u = ed[0];
        if (used[u] && d[u] != -1) {
            col(u);
        }
    }
}

void dfs(int v) {
    used[v] = 1;
    for (auto ed : g[v]) {
        int u = ed[0], w = ed[1];
        int nd = -1;
        if (d[v] != -1) {
            nd = d[v] ^ w;
        }
        if (!used[u]) {
            d[u] = nd;
            dfs(u);
        } else if (d[u] != nd && d[u] != -1) {
            col(u);
        }
    }
}

vector<int> dist(int n, vector<array<int, 3>> ed, int u) {
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        d[i] = -2; used[i] = 0;
    }
    for (auto elem : ed) {
        g[elem[0]].push_back({elem[1], elem[2]});
    }
    d[u] = 0;
    dfs(u);
    vector<int> ans(n, 0);
    for (int i = 0; i < n; ++i) {
        ans[i] = d[i];
        /// cout << d[i] << " ";
    }
    /// cout << endl;
    return ans;
}

int is_bad[MAXN];
int del[MAXN];

bool is_bad_cyc(int v) {
    used[v] = 1;
    for (auto ed : g[v]) {
        int u = ed[0];
        if (del[u]) continue;
        if (used[u] == 2) continue;
        if (used[u] == 0) {
            if (is_bad_cyc(u)) return true;
        } else {
            if (is_bad[v]) return true;
        }
    }
    used[v] = 2;
    return false;
}

vector<int> top;

void build_top(int v) {
    used[v] = 1;
    for (auto ed : g[v]) {
        int u = ed[0];
        if (del[u]) continue;
        if (used[u] == 1) {
            del[v] = true;
            return;
        }
    }
    for (auto ed : g[v]) {
        int u = ed[0];
        if (del[u]) continue;
        if (!used[u]) {
            build_top(u);
        }
    }
    used[v] = 2;
    top.push_back(v);
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int tst;
    cin >> tst;
    while (tst--) {
        int n, m;
        cin >> n >> m;
        fill(is_bad, is_bad + n, 0);
        fill(del, del + n, 0);
        top.clear();
        vector<array<int, 3>> ed(m);
        for (int i = 0; i < m; ++i) {
            cin >> ed[i][0] >> ed[i][1] >> ed[i][2];
            ed[i][0]--; ed[i][1]--;
        }
        int s, t;
        cin >> s >> t;
        s--; t--;
        auto ds = dist(n, ed, s);
        for (auto &elem : ed) {
            swap(elem[0], elem[1]);
        }
        auto dt = dist(n, ed, t);
        for (int i = 0; i < n; ++i) {
            if (ds[i] == -2 || dt[i] == -2) {
                del[i] = 1;
            }
            if (ds[i] == -1 || ds[i] != dt[i]) {
                is_bad[i] = 1;
            }
        }
        for (auto &elem : ed) {
            swap(elem[0], elem[1]);
        }
        for (int i = 0; i < n; ++i) {
            g[i].clear();
        }
        for (auto elem : ed) {
            if (del[elem[0]] || del[elem[1]]) continue;
            g[elem[0]].push_back({elem[1], elem[2]});
        }
        if (del[s] || del[t]) {
            /// cerr << "s or t deleted" << endl;
            cout << "0\n";
            continue;
        }
        fill(used, used + n, 0);
        if (is_bad_cyc(s)) {
            cout << "-1\n";
            continue;
        }
        fill(used, used + n, 0);
        build_top(s);
        if (used[t] != 2) {
            /// cerr << "t inaccessible after build_top" << endl;
            cout << "0\n";
            continue;
        }
        /// cerr << "DAG case" << endl;
        reverse(top.begin(), top.end());
        vector<int> cnt(n, 0), dp(n, 0);
        cnt[s] = 1;
        for (int v : top) {
            for (auto ed : g[v]) {
                int u = ed[0];
                if (del[u]) continue;
                cnt[u] ^= cnt[v];
                dp[u] ^= dp[v];
                if (cnt[v]) {
                    dp[u] ^= ed[1];
                }
            }
        }
        cout << dp[t] << "\n";
    }
    return 0;
}