#include <map>
#include <set>
#include <array>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <cassert>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

const int MAXN = 500500;
vector<pair<int, int>> G[MAXN];
vector<pair<int, int>> GT[MAXN];
vector<int> order;
bool used1[2 * MAXN];
bool used2[2 * MAXN];
int id[2 * MAXN];
int bit;

void dfs(int v) {
  used1[v] = true;
  for (auto t : G[v >> 1]) {
    int u_real = 2 * t.first + ((v & 1) ^ ((t.second >> bit) & 1));
    if (!used1[u_real])
      dfs(u_real);
  }
}

void dfs2(int v) {
  used2[v] = true;
  for (auto t : GT[v >> 1]) {
    int u_real = 2 * t.first + ((v & 1) ^ ((t.second >> bit) & 1));
    if (used1[u_real] && !used2[u_real])
      dfs2(u_real);
  }
  id[v] = order.size();
  order.emplace_back(v);
}

int dp[2 * MAXN];

void solve() {
  int n, m;
  cin >> n >> m;
  vector<pair<pair<int, int>, int>> edges(m);
  for (int i = 0; i < n; ++i) {
    G[i].clear();
    GT[i].clear();
  }
  for (int i = 0; i < m; ++i) {
    int u, v, w;
    cin >> u >> v >> w;
    G[u - 1].emplace_back(v - 1, w);
    GT[v - 1].emplace_back(u - 1, w);
  }
  int a, b;
  cin >> a >> b;
  --a;
  --b;
  int ans = 0;
  for (bit = 0; bit < 30; ++bit) {
    fill(used1, used1 + 2 * n, false);
    fill(used2, used2 + 2 * n, false);
    order.clear();
    dfs(2 * a + 0);
    if (!used1[2 * b + 1])
      continue;
    dfs2(2 * b + 1);
    reverse(order.begin(), order.end());
    fill(dp, dp + 2 * n, 0);
    dp[2 * b + 1] = 1;
    for (int v : order) {
      for (auto t : GT[v >> 1]) {
        int u_real = 2 * t.first + ((v & 1) ^ ((t.second >> bit) & 1));
        if (!used2[u_real])
          continue;
        if (id[u_real] >= id[v]) {
          cout << -1 << '\n';
          return;
        }
        dp[u_real] = (dp[u_real] + dp[v]) & 1;
      }
    }
    ans += dp[2 * a + 0] << bit;
  }
  cout << ans << '\n';
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}