#include "bits/stdc++.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)

using namespace std;

const int maxN = 5e5 + 1;
vector<pair<int, int>> g[maxN], gr[maxN];
bool used[maxN];

vector<int> ts;

void dfs1(int v) {
    used[v] = 1;
    for (auto &[u, w]: gr[v]) {
        if (used[u]) continue;
        dfs1(u);
    }
    ts.push_back(v);
}

bool was[maxN];
bool cyc[maxN];


void dfs2(int v, bool ok) {
    was[v] = true;
    for (auto &[u, w]: g[v]) {
        if (!used[u]) continue;
        if (u == v) ok = true;
        if (was[u]) continue;
        ok = true;
        dfs2(u, ok);
    }
    cyc[v] = ok;
}

int dp[maxN], dp2[maxN];

void dfs3(int v) {
    assert(dp[v] != -1);
    for (auto &[u, w]: g[v]) {
        if (dp[u] == -2) continue;
        if (dp[v] == -2) {
            dp[u] = -2;
        } else if (dp[u] == -1) {
            dp[u] = dp[v] ^ w;
        } else if (dp[u] != (dp[v] ^ w)) {
            dp[u] = -2;
        } else {
            continue;
        }
        dfs3(u);
    }
}

void dfs4(int v) {
    assert(dp2[v] != -1);
    for (auto &[u, w]: gr[v]) {
        if (dp2[u] == -2) continue;
        if (dp2[v] == -2) {
            dp2[u] = -2;
        } else if (dp2[u] == -1) {
            dp2[u] = dp2[v] ^ w;
        } else if (dp2[u] != (dp2[v] ^ w)) {
            dp2[u] = -2;
        } else {
            continue;
        }
        dfs4(u);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    rep(_, m) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        gr[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    dfs1(b);
    reverse(ts.begin(), ts.end());
    for (auto &v: ts) {
        if (was[v]) continue;
        dfs2(v, false);
    }
    reverse(ts.begin(), ts.end());
    for (int i = 1; i <= n; ++i) dp[i] = dp2[i] = -1;
    dp[a] = 0;
    dfs3(a);
    dp2[b] = 0;
    dfs4(b);
    bool ok = true;
    for (auto &v: ts) {
        if (dp[v] == -1 || dp2[v] == -1 || !cyc[v]) continue;
        if ((dp[v] == -2 || dp[v] != dp2[v]) && cyc[v]) ok = false;
    }

    if (ok) {
        vector<int> ans(n + 1), cnt(n + 1);
        cnt[a] = 1;
        for (auto &v: ts) {
            if (cyc[v]) continue;
            for (auto &[u, w]: g[v]) {
                if (cyc[u]) continue;
                ans[u] ^= ans[v];
                cnt[u] ^= cnt[v];
                if (cnt[v]) ans[u] ^= w;
            }
        }
        cout << ans[b] << '\n';
    } else {
        cout << "-1\n";
    }
    for (int i = 1; i <= n; ++i) {
        dp[i] = 0;
        dp2[i] = 0;
        used[i] = false;
        was[i] = false;
        cyc[i] = false;
        g[i].clear();
        gr[i].clear();
    }
    ts.clear();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}