#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
  if (params.count(name)) {
    return stoll(params[name]);
  } else {
    return def;
  }
}

vector<int> gen(int first, int last, int n) {
  vector<int> res(n);
  --first;
  for (int k = 0; k < n; ++k) {
    first = rnd.wnext(first + 1, last - n + k, -5);
    res[k] = first;
  }
  return res;
}

int main(int argc, char *argv[]) {
  registerGen(argc, argv, 1);
  for (int i = 1; i < argc; i++) {
    string s = string(argv[i]);
    if (s.find("=") != string::npos) {
      auto pos = s.find("=");
      params[s.substr(0, pos)] = s.substr(pos + 1);
    } else {
      params[s] = "";
    }
  }

  int maxn = get("maxn");
  int sumK = get("sumK");
  int maxC = get("maxC");

  vector<vector<int>> res;

  int n = rnd.next(3, min(maxn, (int)sqrt(sumK)));
  int first = rnd.next(1, (sumK - n * (n + 1) / 2) / n);

  int count = first + 2 * n - 3;

  int ind = rnd.next(0, n - 3);
  res.resize(n);

  res[0] = gen(1, maxC - (n - 1) - count, first);

  for (int i = 1; i <= ind; ++i) {
    res[i] = gen(1, res[i - 1].back(), first + 2 * i - 1);
    res[i].emplace_back(
        rnd.wnext(res[i - 1].back() + 1, maxC + i - (n - 1) - count, -5));
  }

  for (int i = ind + 1; i < n - 2; ++i) {
    res[i] = gen(1, res[i - 1].back(), first + 2 * i - 1);
    res[i].emplace_back(
        rnd.wnext(res[i - 1].back() + 1, maxC + i - (n - 1), -5));
  }

  res[n - 2] = gen(1, res[n - 3].back(), first + 2 * (n - 2) - 1);
  res[n - 2].emplace_back(
      rnd.wnext(max((int)res[ind].back() + count, res[n - 3].back() + 1),
                maxC + (n - 2) - (n - 1), -5));

  res[n - 1] = gen(res[ind].back(), res[n - 2].back(), first + 2 * n - 3);
  res[n - 1].emplace_back(rnd.wnext(res[n - 2].back() + 1, maxC, 0));

  cout << n << "\n";

  for (int i = 0; i < n; ++i) {
    int k = res[i].size();
    cout << k << "\n";
    for (int j = 0; j < k; ++j) {
      cout << res[i][j] << ((j != k - 1) ? " " : "");
    }
    cout << '\n';
  }
}
