#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
  if (params.count(name)) {
    return stoll(params[name]);
  } else {
    return def;
  }
}

vector<int> gen(int first, int last, int n) {
  vector<int> res(n);
  --first;
  for (int k = 0; k < n; ++k) {
    first = rnd.wnext(first + 1, last - n + k, -5);
    res[k] = first;
  }
  return res;
}

int main(int argc, char *argv[]) {
  registerGen(argc, argv, 1);
  for (int i = 1; i < argc; i++) {
    string s = string(argv[i]);
    if (s.find("=") != string::npos) {
      auto pos = s.find("=");
      params[s.substr(0, pos)] = s.substr(pos + 1);
    } else {
      params[s] = "";
    }
  }

  int blocks = get("blocks");
  int sumK = get("sumK");
  int maxC = get("maxC");
  string mode = params["mode"];

  vector<int> sizes(blocks);

  for (int i = 0; i < blocks; ++i) {
    sizes[i] = rnd.next(1, sumK / 2 - (blocks - i - 1));
    sumK -= sizes[i] * 2;
  }

  int add = 0;

  if (mode == "strong") {
    add = 1;
  } else {
    add = 0;
  }

  vector<vector<int>> res;

  int n = 0;

  for (int i = 0; i < blocks; ++i) {

    vector<vector<int>> temp;
    if (rnd.next(0, 1)) {

      int n = sizes[i];

      temp.resize(n);

      int first = rnd.next(1, maxC / 2 - n + 1);
      int second = rnd.next(maxC / 2 + n, maxC);

      temp[0] = {first, second};

      for (int i = 1; i < n; ++i) {
        temp[i] = {rnd.next(temp[i - 1][0] + add, maxC / 2 - n + i + 1),
                   rnd.next(maxC / 2 + n - i - 1, temp[i - 1][1] - add)};
      }
    } else {

      int n = sizes[i];

      temp.resize(n);

      int first = rnd.next(1, maxC / 2 - n + 1);
      int second = rnd.next(maxC / 2 + 1, maxC - n + 1);

      temp[0] = {first, second};

      for (int i = 1; i < n; ++i) {
        temp[i] = {rnd.next(temp[i - 1][0] + add, second - n + i + 1),
                   rnd.next(temp[i - 1][1] + add, maxC - n + i + 1)};
      }
    }
    n += temp.size();
    for (auto &i : temp) {
      res.emplace_back(i);
    }
  }

  auto ind = rnd.perm(n);

  cout << n << "\n";

  for (int c = 0; c < n; ++c) {
    int i = ind[c];
    int k = res[i].size();
    cout << k << "\n";
    for (int j = 0; j < k; ++j) {
      cout << res[i][j] << ((j != k - 1) ? " " : "");
    }
    cout << '\n';
  }
}
