#include "testlib.h"
#include <bits/stdc++.h>
#include <vector>

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
  if (params.count(name)) {
    return stoll(params[name]);
  } else {
    return def;
  }
}

int main(int argc, char *argv[]) {
  registerGen(argc, argv, 1);
  for (int i = 1; i < argc; i++) {
    string s = string(argv[i]);
    if (s.find("=") != string::npos) {
      auto pos = s.find("=");
      params[s.substr(0, pos)] = s.substr(pos + 1);
    } else {
      params[s] = "";
    }
  }

  int n = get("n");
  int sumK = get("sumK");
  int maxC = get("maxC");
  int k_i = get("k_i");

  cout << n << "\n";

  vector<int> numbers = rnd.distinct(sumK, 1, (int)maxC);
  sort(numbers.begin(), numbers.end());

  vector<vector<int>> res(n);
  int count = 0;
  for (int i = 0; i < n; ++i) {
    int k = rnd.next(1, min(k_i, sumK - (n - i) + 1));
    sumK -= k;
    for (int j = count; j < count + k; ++j) {
      res[i].emplace_back(numbers[j]);
    }
    count += k;
  }
  auto ind = rnd.perm(n);

  for (int t = 0; t < n; ++t) {
    int i = ind[t];
    cout << res[i].size() << '\n';
    for (size_t j = 0; j < res[i].size(); ++j) {
      cout << res[i][j] << ((j != res[i].size() - 1) ? " " : "");
    }
    cout << '\n';
  }
}
