#include <iostream>
#include <vector>
#include <string>

using namespace std;

constexpr long long q = 1'000'000'007; // TRY const

struct hsh {
	long long x;
	unsigned long long y;

	hsh() : x(0), y(0) {}

	hsh(int a) : x(a), y(a) {}

	hsh(const hsh& a) : x(a.x), y(a.y) {}

	void operator+=(hsh b) {
		x += b.x;
		if (x >= q) { // try %
			x -= q;
		}
		y += b.y;
	}

	void operator-=(hsh b) {
		x -= b.x;
		if (x < 0) { // try %
			x += q;
		}
		y -= b.y;
	}

	void operator*=(hsh b) {
		x *= b.x;
		x %= q;
		y *= b.y;
	}

	hsh operator+(hsh b) {
		hsh ans = *this;
		ans += b;
		return ans;
	}

	hsh operator-(hsh b) {
		hsh ans = *this;
		ans -= b;
		return ans;
	}

	hsh operator*(hsh b) {
		hsh ans = *this;
		ans *= b;
		return ans;
	}

	bool operator==(const hsh& a) {
		return a.x == x && a.y == y;
	}

	void print() {
		cout << x << ' ' << y << '\n';
	}
};

const hsh p = 257;

vector<hsh> pp;

string t;

vector<hsh> thsh;

hsh subhash(int l, int r) {
	return thsh[r] - thsh[l] * pp[r - l];
}

vector<hsh> sh;
vector<int> sz;

int main() {
	int n, m;
	cin >> n >> m;

	cin >> t;
	thsh.resize(t.size() + 1);
	pp.resize(t.size() + 1);
	pp[0] = 1;
	for (int i = 0; i < t.size(); i++) {
		thsh[i + 1] = thsh[i] * p + (unsigned)t[i];
		pp[i + 1] = pp[i] * p;
	}

	sh.resize(n);
	sz.resize(n);
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		sz[i] = s.size();
		for (auto c : s) {
			sh[i] = sh[i] * p + (int)c;
		}
	}

	for (int ii = 0; ii < m; ii++) {
		int l, r;
		cin >> l >> r;
		l--;
		long long ans = 0;
		for (int i = 0; i < n; i++) {
			for (int j = l; j + sz[i] <= r; j++) {
				if (subhash(j, j + sz[i]) == sh[i]) {
					ans++;
				}
			}
		}
		cout << ans << '\n';
	}
}

