#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

struct nd {
	int nx[26];
	bool term;
	int p, pp;
	int len;

	nd() {
		for (int i = 0; i < 26; i++) {
			nx[i] = -1;
		}
		term = 0;
		p = -1;
		pp = -1;
		len = 0;
	}
};

vector<nd> s;

int add(int a, char c) {
	c -= 'a';
	if (s[a].nx[c] == -1) {
		s[a].nx[c] = s.size();
		s.emplace_back();
		s.back().len = s[a].len + 1;
	}
	return s[a].nx[c];
}

void build_aho() {
	vector<pair<int, int>> q;
	for (int i = 0; i < 26; i++) {
		if (s[0].nx[i] == -1) {
			s[0].nx[i] = 0;
		} else {
			q.emplace_back(0, i);
		}
	}

	int bg = 0;
	while (bg < q.size()) {
		int b = q[bg].x;
		int x = q[bg].y;
		bg++;

		int a = s[b].nx[x];

		if (b == 0) {
			s[a].p = 0;
			s[a].pp = -1;
		} else {
			s[a].p = s[s[b].p].nx[x];
			if (s[s[a].p].term) {
				s[a].pp = s[a].p;
			} else {
				s[a].pp = s[s[a].p].pp;
			}
		}

		for (int i = 0; i < 26; i++) {
			if (s[a].nx[i] == -1) {
				s[a].nx[i] = s[s[a].p].nx[i];
			} else {
				q.emplace_back(a, i);
			}
		}
	}
}

const int maxx = 1'100'000;

constexpr int blck = 512;

long long d[maxx];
long long dd[maxx / blck + 228];

void add(int a) {
	d[a]++;
	dd[a / blck]++; 
}

long long sum(int l, int r) {
	int ll = (l + blck - 1) / blck;
	int rr = (r + blck - 1) / blck;
	int lr = ll * blck;
	long long ans = 0;
	for (int i = l; i < lr; i++) {
		ans += d[i];
	}
	for (int i = ll; i < rr; i++) {
		ans += dd[i];
	}
	return ans;
}

vector<vector<pair<int, int>>> qu;
vector<long long> ans;

string t;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	cin >> t;

	s.emplace_back();
	for (int i = 0; i < n; i++) {
		string ss;
		cin >> ss;
		int a = 0;
		for (auto i : ss) {
			a = add(a, i);
		}
		s[a].term = true;
	}

	build_aho();

	qu.resize(t.size());
	ans.resize(m);
	for (int ii = 0; ii < m; ii++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		qu[r].emplace_back(l, ii);
	}

	int a = 0;
	for (int i = 0; i < t.size(); i++) {
		a = s[a].nx[t[i] - 'a'];
		// cout << i << ' ' << a << '\n';
		int b = a;
		if (!s[a].term) {
			b = s[a].pp;
		}
		while (b != -1) {
			// cout << i << ' ' << b << '\n';
			add(i - s[b].len + 1);
			b = s[b].pp; // bug p
		}

		for (auto [l, id] : qu[i]) {
			// cout << l << ' ' << i + 1 << '\n';
			ans[id] = sum(l, i + 1); // bug j
		}
	}

	for (auto i : ans) {
		cout << i << '\n';
	}
}