#include <bits/stdc++.h>

using namespace std;

constexpr long long q = 1'000'000'007; // TRY const

struct hsh {
	long long x;
	unsigned long long y;

	hsh() : x(0), y(0) {}

	hsh(int a) : x(a), y(a) {}

	hsh(const hsh& a) : x(a.x), y(a.y) {}

	void operator+=(hsh b) {
		x += b.x;
		if (x >= q) { // try %
			x -= q;
		}
		y += b.y;
	}

	void operator-=(hsh b) {
		x -= b.x;
		if (x < 0) { // try %
			x += q;
		}
		y -= b.y;
	}

	void operator*=(hsh b) {
		x *= b.x;
		x %= q;
		y *= b.y;
	}

	hsh operator+(hsh b) {
		hsh ans = *this;
		ans += b;
		return ans;
	}

	hsh operator-(hsh b) {
		hsh ans = *this;
		ans -= b;
		return ans;
	}

	hsh operator*(hsh b) {
		hsh ans = *this;
		ans *= b;
		return ans;
	}

	bool operator==(const hsh& a) const {
		return a.x == x && a.y == y;
	}

	void print() {
		cout << x << ' ' << y << '\n';
	}
};

struct hshsh {
	size_t operator()(const hsh& k) const {
   		return (size_t)k.x + (size_t)k.y;
    }
};

const hsh p = 257;

vector<hsh> pp;

string t;

vector<hsh> thsh;

hsh subhash(int l, int r) {
	return thsh[r] - thsh[l] * pp[r - l];
}

set<int> len;
vector<unordered_set<hsh, hshsh>> shs;

const int maxx = 1 << 20;

int d[maxx * 2 + 3];

void add(int a) {
	a += maxx;
	while (a > 0) {
		d[a]++;
		a /= 2;
	}
}

long long sum(int l, int r, int ll, int rr, int a) {
	if (ll >= r || l >= rr) {
		return 0;
	}
	if (ll <= l && r <= rr) {
		return d[a];
	}
	return sum(l, (l + r) / 2, ll, rr, a * 2) + sum((l + r) / 2, r, ll, rr, a * 2 + 1);
}

vector<vector<pair<int, int>>> qu;
vector<long long> ans;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	cin >> t;
	thsh.resize(t.size() + 1);
	pp.resize(t.size() + 1);
	pp[0] = 1;
	for (int i = 0; i < t.size(); i++) {
		thsh[i + 1] = thsh[i] * p + (unsigned)t[i];
		pp[i + 1] = pp[i] * p;
	}

	shs.resize(t.size());
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		if (s.size() > t.size()) {
			continue;
		}
		len.insert(s.size() - 1);
		hsh sh = 0;
		for (auto c : s) {
			sh = sh * p + (int)c;
		}
		shs[s.size() - 1].insert(sh);
	}

	qu.resize(t.size());
	ans.resize(m);
	for (int ii = 0; ii < m; ii++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		qu[r].emplace_back(l, ii);
	}

	for (int i = 0; i < t.size(); i++) {
		for (auto j : len) {
			if (j > i) {
				continue;
			}
			if (shs[j].count(subhash(i - j, i + 1))) {
				// cout << 1 << ' ' << i - sz[j] + 1 << '\n';
				add(i - j);
			}
		}
		for (auto [l, id] : qu[i]) {
			// cout << l << ' ' << i + 1 << '\n';
			ans[id] = sum(0, maxx, l, i + 1, 1); // bug j
		}
	}

	for (auto i : ans) {
		cout << i << '\n';
	}
}

