#include <iostream>
#include <vector>
#include <random>
#include <algorithm>
#include <ctime>
#include <set>
#include <map>
#include <complex>
#include <chrono>
#include <sstream>
#include <fstream>
#include <deque>
#include <cassert>
#include <unordered_map>
#include <numeric>
#include <bitset>
#include <cmath>

#pragma GCC optimize("O3")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ll> vll;
typedef complex<double> cd;

const char el = '\n';
const int inf = 1000'000'000, mod = 998244353, mod2 = 1000'000'007;
const ll llinf = 4'000'000'000'000'000'000;
const ld pi = 3.141592653589793238462643383279502884197169399375105820974944592307816406286208998628034825;

#define forn(i, n) for (int (i) = 0; i < (int)(n); ++(i))
#define firn(i, n) for (int (i) = 1; i < (int)(n); ++(i))
//#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)
//#define firn(i, n) for (int (i) = 1; (i) != (n); (i)++)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << el
#define fi first
#define se second
//#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())

template<typename T> bool uin(T& a, T b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T& a, T b) { if (b > a) { a = b; return true; } return false; }
template<class iterator> void output(iterator begin, iterator end, char p = ' ', ostream & out = cout) { while (begin != end) { out << (*begin) << p; begin++; } out << el; }
template<class T> void output(T x, char p = ' ', ostream & out = cout) { output(all(x), p, out); }

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
mt19937_64 rnd_64(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1 << 23, H = 11;
int T[N], TT[N >> H];
inline void inc(int pos) {
    ++T[pos];
    ++TT[pos >> H];
}

int sum(int l, int r) {
    int res = 0;
    if ((l >> H) == (r >> H)) {
        for (int i = l; i <= r; ++i) res += T[i];
        return res;
    }
    int L = ((l >> H) + 1) << H;
    for (int i = l; i < L; ++i) res += T[i];
    int R = (r >> H);
    L >>= H;
    for (int i = L; i <= R; ++i) res += TT[i];
    return res;
}

map<char, int> nxt[N], g[N];
int p[N], len[N], suff[N], supersuf[N];
char c[N];
bool term[N];
int cnt = 1;

void init() {
    p[0] = -1;
}

bool canNext(int v, char c) {
    return nxt[v].find(c) != nxt[v].end();
}

int go(int v, int c);

int _suff(int v) {
    if (suff[v] == -1) {
        if (p[v] == 0) {
            suff[v] = 0;
        } else {
            suff[v] = go(_suff(p[v]), c[v]);
        }
    }
    return suff[v];
}

int _supersuf(int v) {
    if (supersuf[v] == -1) {
        if (p[v] == 0) {
            supersuf[v] = 0;
        } else {
            int sf = _suff(v);

            if (term[sf]) supersuf[v] = sf;
            else supersuf[v] = _supersuf(sf);
        }
    }
    return supersuf[v];
}

int go(int v, int c) {
    if (g[v].find(c) != g[v].end()) {
        return g[v][c];
    }
    if (canNext(v, c)) {
        return g[v][c] = nxt[v][c];
    }
    return g[v][c] = v == 0 ? 0 : go(_suff(v), c);
}

void add_string(const string& s) {
    int v = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (!canNext(v, s[i])) {
            nxt[v][s[i]] = cnt;
            p[cnt] = v;
            len[cnt] = len[v] + 1;
            suff[cnt] = supersuf[cnt] = -1;
            c[cnt] = s[i];
            cnt++;
        }
        v = nxt[v][s[i]];
    }
    term[v] = true;
}

string s, t;

struct query {
    int l, r, i;
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    init();
    int n, m;
    cin >> n >> m;
    cin >> s;
    forn(i, n) {
        cin >> t;
        add_string(t);
    }
    vector<query> q(m);
    forn(i, m) {
        cin >> q[i].l >> q[i].r;
        q[i].i = i;
        q[i].l--, q[i].r--;
    }
    sort(all(q), [](const query& a, const query& b) { return a.l < b.l; });
    vector<int> ans(m);
    vector<vector<int>> R(s.size());
    forn(i, m) {
        R[q[i].r].push_back(i);
    }
    firn(v, cnt) {
        _supersuf(v);
    }
    int v = 0;
    forn(i, s.size()) {
        v = go(v, s[i]);
        int u = term[v] ? v : supersuf[v];
        while (u > 0) {
            inc(i - len[u] + 1);
            u = supersuf[u];
        }
        for (auto j: R[i]) {
            ans[q[j].i] = sum(q[j].l, i);
        }
    }
    forn(i, m) cout << ans[i] << ' ';
    cout << el;
    return 0;
}
