#include <iostream>
#include <set>
#include <algorithm>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int32_t n;
    std::cin >> n;

    std::pair<int32_t, int32_t>* arr = new std::pair<int32_t, int32_t>[n];
    for(int32_t i = 0; i < n; i++)
        std::cin >> arr[i].first >> arr[i].second;
    std::sort(arr, arr + n);

    int32_t* suf_max = new int32_t[n + 1];
    suf_max[0] = -1;
    for(int32_t i = 1; i <= n; i++)
        suf_max[i] = std::max(suf_max[i - 1], arr[n - i].second);

    int32_t ans = INT32_MAX;
    for(int32_t i = 0; i < n; i++) {
        int32_t max1 = arr[i].first, max2 = -1;
        int32_t added_max2_smaller = -1, added_max2_larger = INT32_MAX;

        int32_t suffix = arr + n - (std::lower_bound(arr, arr + n, std::pair<int32_t, int32_t>(arr[i].first + 1, -1)));
        max2 = suf_max[suffix];

        for(int32_t j = 0; j < i; j++)
            if(arr[j].first <= arr[i].first) {
                if(arr[j].second >= arr[i].first)
                    added_max2_larger = std::min(added_max2_larger, arr[j].second);
                if(arr[j].second <= arr[i].first)
                    added_max2_smaller = std::max(added_max2_smaller, arr[j].second);
            }
        for(int32_t j = i + 1; j < n; j++)
            if(arr[j].first <= arr[i].first) {
                if(arr[j].second >= arr[i].first)
                    added_max2_larger = std::min(added_max2_larger, arr[j].second);
                if(arr[j].second <= arr[i].first)
                    added_max2_smaller = std::max(added_max2_smaller, arr[j].second);
            }

        if(max2 < max1)
            max2 = std::max(max2, added_max2_smaller);
        if(max2 < max1 && std::abs(added_max2_larger - max1) < std::abs(max2 - max1))
            max2 = added_max2_larger;

        ans = std::min(ans, std::abs(max2 - max1));
    }

    std::cout << ans << "\n\n";
    return 0;
}



