// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 500100;

int n;
std::pair<int, int> a[N];

bool check(int i, int j) {
    int maxA = a[i].first;
    int maxB = a[j].second;

    for (int k = 0; k < n; ++k) {
        if (k == i || k == j) {
            continue;
        }
        if (a[k].first <= maxA || a[k].second <= maxB) {
            continue;
        }

        return false;
    }

    return true;
}

void run() {
    scanf("%d", &n);

    int minFirst = INF, maxFirst = -INF;
    int minSecond = INF, maxSecond = -INF;
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &a[i].first, &a[i].second);

        smin(minFirst, a[i].first);
        smax(maxFirst, a[i].first);
        smin(minSecond, a[i].second);
        smax(maxSecond, a[i].second);
    }

    std::vector<int> positions;
    for (int i = 0; i < n; ++i) {
        if (a[i].first == minFirst || a[i].first == maxFirst ||
            a[i].second == minSecond || a[i].second == maxSecond) {
            positions.push_back(i);
        }
    }
    std::shuffle(positions.begin(), positions.end(), rnd);

    positions.resize(std::min(positions.size(), (size_t)sqrt((int)2e8 / n)));

    int ans = INF;
    for (int i = 0; i < (int)positions.size(); ++i) {
        for (int j = 0; j < i; ++j) {
            int pos1 = positions[i];
            int pos2 = positions[j];
            if (check(pos1, pos2)) {
                smin(ans, abs(a[pos1].first - a[pos2].second));
            }
            if (check(pos2, pos1)) {
                smin(ans, abs(a[pos2].first - a[pos1].second));
            }
        }
    }

    printf("%d\n", ans);
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    #ifdef PERVEEVM_LOCAL
        auto start = std::chrono::high_resolution_clock::now();
    #endif

    run();

    #ifdef PERVEEVM_LOCAL
        auto end = std::chrono::high_resolution_clock::now();
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
