#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

std::vector<int> RandSet(int n, int k, int w) {
    if (w == 0) {
        auto res = rnd.distinct(k, 1, n);
        sort(res.begin(), res.end());
        return res;
    }
    std::vector<int> ans;
    for (int i = 0; i < k; i++) {
        ans.push_back(rnd.wnext(n - k + 1, w));
    }
    std::sort(ans.begin(), ans.end());
    for (int i = 0; i < k; i++) {
        ans[i] += i + 1;
    }
    return ans;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int t = opt<int>("t");
    int n = opt<int>("n");
    int k = opt<int>("k");
    int w = (has_opt("w") ? opt<int>("w") : 0);
    
    if (has_opt("q")) {
        println(opt<int>("q"), opt<int>("q"));
    } else {
        println(-1, 3500);
    }

    println(t);
    for (int i = 0; i < t; i++) {
        println("set");

        int cur_n = n;
        if (cur_n < 0) {
            cur_n = rnd.next(1, -cur_n);
        }

        int cur_k = k;
        if (cur_k < 0) {
            cur_k = rnd.next(1, min(cur_n, -cur_k));
        }
        if (cur_k > cur_n) {
            cur_k = cur_n;
        }

        vector<pair<int, int>> segments;
        if (cur_n <= 32) {
            segments.emplace_back(1, cur_n);
        } else {
            segments.emplace_back(1, 32);
            int L = 32;
            while (L < cur_n) {
                segments.emplace_back(L + 1, min(2 * L, cur_n));
                L = segments.back().second;
            }
        }

        int cur_w = rnd.next(-w, w);
        vector<int> pos;
        for (int it = 0; it < cur_k; it++) {
            auto seg = rnd.any(segments);
            pos.emplace_back(rnd.wnext(seg.first, seg.second, cur_w));
        }
        sort(pos.begin(), pos.end());
        int interval = rnd.next(2);
        for (int x = 1; x < cur_k; x++) {
            while (pos[x] <= pos[x - 1] + interval) {
                for (int y = x; y < cur_k; y++) {
                    pos[y]++;
                }
            }
        }

        while (!pos.empty() && pos.back() > cur_n) {
            pos.pop_back();
        }
        if (pos.empty()) {
            pos.emplace_back(rnd.next(1, cur_n));
        }
        println(cur_n, pos.size());
        println(pos);
    }

    return 0;
}
