#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;

ll GetSegmentSum(int L, int R) {
    return (ll)(R - L + 1) * (ll)(L + R) / 2LL;
}

void ReadSetTestCase(int maxn, int maxk, int mink) {
    int n = inf.readInt(1, maxn, "n");
    inf.readSpace();
    int k = inf.readInt(mink, min(n, maxk), "k");
    inf.readEoln();

    vector<int> pos = inf.readIntegers(k, 1, n, "pos");
    inf.readEoln();

    for (int i = 0; i < k - 1; ++i) {
        ensuref(pos[i] < pos[i + 1], "positions should increase");
    }
}

void ReadAdaptiveTestCase(int maxn, int maxk, int mink) {
    int n = inf.readInt(1, maxn, "n");
    inf.readSpace();
    int k = inf.readInt(mink, min(n, maxk), "k");
    inf.readSpace();
    ll sum = inf.readLong(GetSegmentSum(1, k), GetSegmentSum(n - k + 1, n), "s");
    inf.readEoln();
}

void ReadTestCases(int maxt, int maxn, int maxk, int mink) {
    int t = inf.readInt(1, maxt, "t");
    inf.readEoln();

    for (int test_num = 0; test_num < t; ++test_num) {
        setTestCase(test_num + 1);

        string type = inf.readToken("set|adaptive", "type");
        inf.readEoln();

        if (type == "set") {
            ReadSetTestCase(maxn, maxk, mink);
        } else if (type == "adaptive") {
            ReadAdaptiveTestCase(maxn, maxk, mink);
        } else {
            assert(false);
        }
    }
}

constexpr int kMaxT = 50;
constexpr int kMaxxN = 1'000'000'000;

constexpr int kMaxN[7] = {kMaxxN, 1000, 1000, kMaxxN, kMaxxN, kMaxxN, kMaxxN};
constexpr int kMaxK[7] = {100, 100, 100, 30, 3, 4, 100};
constexpr int kMinK[7] = {1, 1, 1, 1, 3, 4, 1};
constexpr int kMinQ[7] = {3500, 1000, 600, 1000, 33, 34, -1};
constexpr int kMaxQ[7] = {3500, 1000, 600, 1000, 33, 34, 3500};

int main(int argc, char** argv) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());
    
    inf.readInt(kMinQ[group], kMinQ[group], "minQ");
    inf.readSpace();
    inf.readInt(kMaxQ[group], kMaxQ[group], "maxQ");
    inf.readEoln();

    ReadTestCases(kMaxT, kMaxN[group], kMaxK[group], kMinK[group]);

    inf.readEof();

    return 0;
}
