#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerScorer(argc, argv, [](std::vector<TestResult> trs) {
        map<string, double> res;
        
        vector<double> scores = {0, 5, 9, 10, 13, 13, 50};

        for (auto& i : trs) {
          if (i.verdict != OK) {
            res[i.group] = 0;
          } else {
            if (res.count(i.group)) {
              res[i.group] = min(res[i.group], i.points);
            } else {
              res[i.group] = i.points;
            }
          }
        }

        double score = 0;

        for (auto i : res) {
          score += scores[i.first[0] - '0'] * i.second / 100;
        }

        return score;
    });
}
