/*
    author:  Maksim1744
    created: 18.02.2023 14:58:39
*/

#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;

#define mp   make_pair
#define pb   push_back
#define eb   emplace_back

#define sum(a)     ( accumulate ((a).begin(), (a).end(), 0ll))
#define mine(a)    (*min_element((a).begin(), (a).end()))
#define maxe(a)    (*max_element((a).begin(), (a).end()))
#define mini(a)    ( min_element((a).begin(), (a).end()) - (a).begin())
#define maxi(a)    ( max_element((a).begin(), (a).end()) - (a).begin())
#define lowb(a, x) ( lower_bound((a).begin(), (a).end(), (x)) - (a).begin())
#define uppb(a, x) ( upper_bound((a).begin(), (a).end(), (x)) - (a).begin())

template<typename T>             vector<T>& operator--            (vector<T> &v){for (auto& i : v) --i;            return  v;}
template<typename T>             vector<T>& operator++            (vector<T> &v){for (auto& i : v) ++i;            return  v;}
template<typename T>             istream& operator>>(istream& is,  vector<T> &v){for (auto& i : v) is >> i;        return is;}
template<typename T>             ostream& operator<<(ostream& os,  vector<T>  v){for (auto& i : v) os << i << ' '; return os;}
template<typename T, typename U> pair<T,U>& operator--           (pair<T, U> &p){--p.first; --p.second;            return  p;}
template<typename T, typename U> pair<T,U>& operator++           (pair<T, U> &p){++p.first; ++p.second;            return  p;}
template<typename T, typename U> istream& operator>>(istream& is, pair<T, U> &p){is >> p.first >> p.second;        return is;}
template<typename T, typename U> ostream& operator<<(ostream& os, pair<T, U>  p){os << p.first << ' ' << p.second; return os;}
template<typename T, typename U> pair<T,U> operator-(pair<T,U> a, pair<T,U> b){return mp(a.first-b.first, a.second-b.second);}
template<typename T, typename U> pair<T,U> operator+(pair<T,U> a, pair<T,U> b){return mp(a.first+b.first, a.second+b.second);}
template<typename T, typename U> void umin(T& a, U b){if (a > b) a = b;}
template<typename T, typename U> void umax(T& a, U b){if (a < b) a = b;}

#ifdef HOME
#define SHOW_COLORS
#include "/mnt/c/Libs/tools/print.cpp"
#else
#define show(...) void(0)
#define debugf(fun)   fun
#define debugv(var)   var
#define mclock    void(0)
#define shows     void(0)
#define debug  if (false)
#define OSTREAM(...)    ;
#define OSTREAM0(...)   ;
#endif

template<class Fun>
class y_combinator_result {
    Fun fun_;
public:
    template<class T>
    explicit y_combinator_result(T &&fun): fun_(std::forward<T>(fun)) {}

    template<class ...Args>
    decltype(auto) operator()(Args &&...args) {
        return fun_(std::ref(*this), std::forward<Args>(args)...);
    }
};
template<class Fun>
decltype(auto) y_combinator(Fun &&fun) {
    return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun));
}
// auto gcd = std::y_combinator([](auto gcd, int a, int b) -> int {
//     return b == 0 ? a : gcd(b, a % b);
// });

#ifdef HOUSE

#define INTERACT

#endif

// mt19937_64 rng(48379267);
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll rnd (ll l, ll r) { return (ll)(rng() % (r - l + 1)) + l; }
ll rnd (ll r)       { return rng() % r; }
ll rnd ()           { return rng(); }
ld rndf()           { return (ld)rng() / (ld)ULLONG_MAX; }
ld rndf(ld l, ld r) { return rndf() * (r - l) + l; }

int max_que = 0;

void test_case(int test) {
    ll n;
    int k;

    int que = 0;

    #ifdef INTERACT
    n = 1e9;
    k = 100;
    #else
    cin >> n >> k;
    #endif

    auto pref = [&](ll x) {
        return x * (x + 1) / 2;
    };

    map<ll, ll> mem;
    #ifdef INTERACT
    set<ll> vals;
    while (vals.size() < k)
        vals.insert(10000000 + rnd(1, 100000));
    #endif

    auto ask = [&](ll r) -> ll {
        if (r <= 0) return 0;
        if (mem.count(r)) return mem[r];
        ++que;
        #ifdef INTERACT
        ll e = pref(r);
        for (ll u : vals)
            if (u <= r)
                e -= u;
        ll k = e;
        #else
        cout << "? " << r << endl;
        ll k;
        cin >> k;
        if (k == -1) exit(0);
        #endif
        return mem[r] = pref(r) - k;
    };

    auto seg_sum = [&](ll l, ll r) {
        return pref(r) - pref(l - 1);
    };

    vector<ll> ans;
    auto solve = y_combinator([&](auto solve, ll l, ll r, int lk, int rk, ll sm, ll left_sum) -> int {
        if (sm == 0) return 0;
        rk = min((ll)rk, r - l + 1);
        lk = max(lk, 1);
        while (seg_sum(l, l + rk - 1) > sm) --rk;
        while (seg_sum(r - lk + 1, r) < sm) ++lk;
        assert(lk <= rk);
        if (rk == 1) {
            ans.pb(sm);
            return 1;
        }

        if (lk == 1) {
            assert(l <= sm && sm <= r);
            if (ask(sm - 1) - left_sum == 0) {
                ans.pb(sm);
                return 1;
            }
            lk = 2;
        }

        if (lk == rk) {
            if (r - l + 1 == lk) {
                for (int i = l; i <= r; ++i) {
                    ans.pb(i);
                }
                return lk;
            }
            if (r - l + 1 == lk + 1) {
                int extra = seg_sum(l, r) - sm;
                for (int i = l; i <= r; ++i) {
                    if (i != extra)
                        ans.pb(i);
                }
                return lk;
            }
        }

        auto chck = [&](int k) -> tuple<bool, int, ll> {
            ll mid = sm / k;
            assert(l <= mid && mid <= r);
            ll sl = ask(mid) - left_sum;
            if (sl != 0 && sl != sm) {
                if (false) {
                    int on_left = solve(l, mid, 1, rk - 1, sl, left_sum);
                    int on_right = solve(mid + 1, r, lk - on_left, rk - on_left, sm - sl, left_sum + sl);
                    return {true, on_left + on_right, sl};
                } else {
                    int on_right = solve(mid + 1, r, 1, rk - 1, sm - sl, left_sum + sl);
                    int on_left = solve(l, mid, lk - on_right, rk - on_right, sl, left_sum);
                    return {true, on_left + on_right, sl};
                }
            }
            return {false, -1, sl};
        };

        int L = lk, R = rk;
        while (L != R) {
            int k = (L + R) / 2;
            auto [can, kk, sl] = chck(k);
            if (can) return kk;
            ll mid = sm / k;
            if (sl == 0) {
                l = mid + 1;
                R = k - 1;
            } else {
                r = mid;
                L = k + 1;
            }
        }

        int k = L;
        auto [can, kk, sl] = chck(k);
        if (can) return kk;

        assert(false);
    });

    solve(1, n, k, k, ask(n), 0);
    #ifdef INTERACT
    vector<ll> vu(vals.begin(), vals.end());
    sort(ans.begin(), ans.end());
    if (vu != ans) {
        cerr << "WA !!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;
        exit(0);
    }
    cerr << "que: " << que << endl;
    #else
    cout << "! ";
    cout << ans << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
    #endif

    max_que = max(max_que, que);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int T;
    #ifdef INTERACT
    T = 100;
    #else
    cin >> T;
    #endif
    for (int test = 1; test <= T; ++test) {
        test_case(test);
    }

    #ifdef INTERACT
    cerr << "max_que: " << max_que << endl;
    #endif

    return 0;
}
