#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll GetSegmentSum(int L, int R) {
    return (ll)(R - L + 1) * (ll)(L + R) / 2LL;
}

map<int, ll> cache;

ll Ask(int p) {
    if (cache.find(p) != cache.end()) {
        return cache[p];
    }
    cout << "? " << p << endl;
    ll ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
    ans = GetSegmentSum(1, p) - ans;
    cache[p] = ans;
    return ans;
}

void Answer(const vector<int>& p) {
    cout << "! ";
    for (int i : p) {
        cout << i << " ";
    }
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
}

pair<int, int> GetPossibleSegment(int k, int l, int r, ll s) {
    if (s == 0) {
        return make_pair(0, 0);
    }
    k = min(k, r - l + 1);
    if (s < l || s > GetSegmentSum(r - k + 1, r)) {
        return make_pair(-1, -1);
    }
    int sl = -1;
    int sr = -1;
    {
        int L = 1;
        int R = k + 1;
        while (R - L > 1) {
            int h = (L + R) / 2;
            if (GetSegmentSum(l, l + h - 1) <= s) {
                L = h;
            } else {
                R = h;
            }
        }
        sr = L;
    }
    {
        int L = 0;
        int R = k;
        while (R - L > 1) {
            int h = (L + R) / 2;
            if (GetSegmentSum(r - h + 1, r) >= s) {
                R = h;
            } else {
                L = h;
            }
        }
        sl = R;
    }
    if (sl > sr) {
        sl = sr = -1;
    }
    return make_pair(sl, sr);
}

pair<int, int> possible_segment(int k, int cnt_l, int cnt_r, ll s, int l, int r) {
    auto cur = GetPossibleSegment(k, l, r, s);
    cnt_l = max(cnt_l, cur.first);
    cnt_r = min(cnt_r, cur.second);
    return make_pair(cnt_l, cnt_r);
}

vector<int> ans;

int solve(int k, int l, int r, int cl, int cr, ll sl, ll sr) {
    ll s = sr - sl;
    //cout << k << " " << l << " " << r << " " << cl << " " << cr << " " << s << endl;
    if (s == 0) {
        return 0;
    }
    if (l <= s && s <= 2 * l) {
        ans.emplace_back(s);
        return 1;
    }
    if (s == GetSegmentSum(l, r)) {
        for (int i = l; i <= r; i++) {
            ans.emplace_back(i);
        }
        return r - l + 1;
    }
    auto [cnt_l, cnt_r] = possible_segment(k, cl, cr, s, l, r);
    if (cnt_l >= r - l) {
        int missing = GetSegmentSum(l, r) - s;
        for (int i = l; i <= r; i++) {
            if (i != missing) {
                ans.emplace_back(i);
            }
        }
        return r - l;
    }
    assert(cnt_l <= cnt_r);
    if (cnt_r == 1) {
        ans.emplace_back(s);
        return 1;
    }
    int cnt_mid = (cnt_l + cnt_r + 1) / 2;
    int cur_x = (s / cnt_mid);
    if (cur_x < l) {
        cnt_r = cnt_mid - 1;
        return solve(k, cur_x + 1, r, cnt_l, cnt_r, sl, sr);
    } else if (cur_x > r) {
        cnt_l = cnt_mid + 1;
        return solve(k, l, cur_x, cnt_l, cnt_r, sl, sr);
    }
    ll s_mid = Ask(cur_x);
    if (s_mid != sl && s_mid != sr) {
        auto psl = possible_segment(k, 0, cnt_r, s_mid - sl, l, cur_x);
        auto psr = possible_segment(k, 0, cnt_r, sr - s_mid, cur_x + 1, r);
        cnt_r = min(cnt_r, psl.second + psr.second);
        cnt_l = max(cnt_l, psl.first + psr.first);
        pair<int, int> sgl = {max(psl.first, cnt_l - psr.second), min(psl.second, cnt_r - psr.first)};
        pair<int, int> sgr = {max(psr.first, cnt_l - psl.second), min(psr.second, cnt_r - psl.first)};
        int res = 0;
        if (sgl.second - sgl.first <= sgr.second - sgr.first) {
            res += solve(k, l, cur_x, sgl.first, sgl.second, sl, s_mid);
            res += solve(k, cur_x + 1, r, max(sgr.first, cnt_l - res), min(sgr.second, cnt_r - res), s_mid, sr);
        } else {
            res += solve(k, cur_x + 1, r, sgr.first, sgr.second, s_mid, sr);
            res += solve(k, l, cur_x, max(sgl.first, cnt_l - res), min(sgl.second, cnt_r - res), sl, s_mid);
        }
        return res;
    }
    if (s_mid == sl) {
        cnt_r = cnt_mid - 1;
        return solve(k, cur_x + 1, r, cnt_l, cnt_r, sl, sr);
    } else {
        cnt_l = cnt_mid + 1;
        return solve(k, l, cur_x, cnt_l, cnt_r, sl, sr);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    ans.clear();
    solve(k, 1, n, k, k, 0, Ask(n));
    Answer(ans);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        cache.clear();
        solve();
    }

    return 0;
}
