#include "testlib.h"
#include <string>

using namespace std;

const int MAX_N = 800;
const int MAX_M = 3'000;
const int MAX_S = 1'000'000'000;
const int MAX_P = 1'000'000'000;
const int MAX_W = 1'000'000'000;

const int maxn[7] = {MAX_N, MAX_N, MAX_N, 10, 100, 100, MAX_N};
const int maxs[7] = {MAX_S, MAX_S, MAX_S, MAX_S, 100, MAX_S, MAX_S};
const int maxw[7] = {MAX_W, 1, MAX_W, MAX_W, MAX_W, MAX_W, MAX_W};

struct Edge {
    int a, b, s;
};

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());

    int n = inf.readInt(2, maxn[group], "n");
    inf.readSpace();
    int m = inf.readInt(1, MAX_M, "m");
    inf.readSpace();
    int p = inf.readInt(0, MAX_P, "p");
    inf.readSpace();
    int g = inf.readInt(group, group, "g");
    inf.readEoln();

    if (group == 2) {
        ensuref(m == n - 1, "edges not form a path, m=%d, n=%d", m, n);
    }

    for (int i = 1; i <= n; ++i) {
        int w = inf.readInt(1, maxw[group], "w_" + to_string(i));
        if (i < n) inf.readSpace();
    }
    inf.readEoln();

    for (int i = 1; i <= m; i++) {
        Edge e;
        e.a = inf.readInt(1, n, "a");
        inf.readSpace();
        e.b = inf.readInt(1, n, "b");
        inf.readSpace();
        e.s = inf.readInt(1, maxs[group], "s");
        inf.readEoln();

        if (group == 2) {
            ensuref(e.a == i && e.b == i + 1, "incorrect edge (%d, %d), but must be (%d, %d)", e.a, e.b, i, i + 1);
        }
    }

    inf.readEof();
    return 0;
}
