#include "bits/stdc++.h"

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define rep1(i, n) for (int i = 1; i < (n); ++i)
#define rep1n(i, n) for (int i = 1; i <= (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define pb push_back
#define eb emplace_back
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define each(x, a) for (auto &x : a)
#define ar array
#define vec vector
#define range(i, n) rep(i, n)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;

using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;

int Bit(int mask, int b) { return (mask >> b) & 1; }

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INFi = 1e9;
const ll INF = 2e18;
const int LG = 20;
const int maxN = 3e5 + 10;
const int md = 1e9 + 7;

double GetTime() {
    return (double) clock() / (double) CLOCKS_PER_SEC;
}

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<vpi> g(n);
    vi w(n);
    rep(i, n) cin >> w[i];
    rep(i, m) {
        int a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        g[a].emplace_back(b, s);
    }
    vector<ll> dp(n, -1);
    dp[0] = p;
    auto relax = [&] () {
        priority_queue<pair<ll, int>> pq;
        rep(i, n) if (dp[i] != -1) pq.push({dp[i], i});
        while (!pq.empty()) {
            auto [x, v] = pq.top();
            pq.pop();
            if (dp[v] != x) continue;
            for(auto &[u, s] : g[v]) {
                if (dp[u] < dp[v] - s) {
                    dp[u] = dp[v] - s;
                    pq.push({dp[u], u});
                }
            }
        }
    };
    int ans = 0;
    relax();
    while (dp[n - 1] == -1 && GetTime() < 1.0) {
        auto dp2 = dp;
        rep(i, n) if (dp[i] != -1) dp2[i] = max(dp2[i], dp[i] + w[i]);
        swap(dp, dp2);
        ans++;
        relax();
    }
    cout << (dp[n-1] == -1 ? -1 : ans) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
//    cout << setprecision(15) << fixed;
    int t = 1;
//    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}
