#include "bits/stdc++.h"

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define rep1(i, n) for (int i = 1; i < (n); ++i)
#define rep1n(i, n) for (int i = 1; i <= (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define pb push_back
#define eb emplace_back
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define each(x, a) for (auto &x : a)
#define ar array
#define vec vector
#define range(i, n) rep(i, n)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;

using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;

int Bit(int mask, int b) { return (mask >> b) & 1; }

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INFi = 1e9;
const ll INF = 2e18;
const int LG = 20;
const int maxN = 3e5 + 10;
const int md = 1e9 + 7;

struct PathParams {
    ll num_show;
    ll money;
};

bool operator==(const PathParams &a, const PathParams &b) {
    return tie(a.num_show, a.money) == tie(b.num_show, b.money);
}

bool operator!=(const PathParams &a, const PathParams &b) {
    return !(a == b);
}

bool operator<(const PathParams &a, const PathParams &b) {
    if (a.num_show != b.num_show) return a.num_show < b.num_show;
    return a.money > b.money;
}

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<vector<pair<int, int>>> g1(n);
    vi w(n);
    vector<vl> g(n, vl(n, INF));
    rep(i, n) g[i][i] = 0;
    rep(i, n) cin >> w[i];
    rep(i, m) {
        int a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        g1[a].emplace_back(b, s);
    }
    rep(i, n) {
        priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<>> pq;
        pq.push({0, i});
        while (!pq.empty()) {
            auto [dist, v] = pq.top();
            pq.pop();
            if (dist != g[i][v]) continue;
            for(auto &[u, s] : g1[v]) {
                if (g[i][u] > dist + s) {
                    g[i][u] = dist + s;
                    pq.push({dist + s, u});
                }
            }
        }
    }
    vi ord(n);
    iota(all(ord), 0);
    sort(all(ord), [&](const int &i, const int &j) { return w[i] < w[j]; });
    vector<PathParams> dp(n, {INF, 0});
    dp[0] = {0, p};
    ll ans = 0;
    for (auto &i: ord) {
        if (dp[i].num_show == INF) continue;
        rep(j, n) {
            if (i == j || g[i][j] == INF) continue;
            auto cur = dp[i];
            ll need = max(0ll, (g[i][j] - cur.money + w[i] - 1) / w[i]);
            cur.money += need * w[i];
            cur.num_show += need;
            cur.money -= g[i][j];
            assert(cur.money >= 0);
            if (cur < dp[j]) dp[j] = cur;
        }
    }
    cout << (dp[n - 1].num_show == INF ? -1 : dp[n - 1].num_show) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
//    cout << setprecision(15) << fixed;
    int t = 1;
//    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}
