#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 805;
const int INF = (int) 1e15;

vector<pair<int, int>> g[MAXN];
int ww[MAXN];

int dists[MAXN][MAXN];

void dijkstra(int start) {
  dists[start][start] = 0;
  set<pair<int, int>> heap{{dists[start][start], start}};
  while (!heap.empty()) {
    auto [dist, v] = *heap.begin();
    heap.erase(heap.begin());
    if (dist != dists[start][v]) {
      continue;
    }
    for (auto [u, w] : g[v]) {
      if (dist + w < dists[start][u]) {
        dists[start][u] = dist + w;
        heap.insert({dists[start][u], u});
      }
    }
  }
}

void sol1(int n, int p) {
  dijkstra(1);
  cout << (dists[1][n] == INF ? -1 : max(0LL, dists[1][n] - p)) << '\n';
}

void sol2(int n, int p) {
  int ans = INF;
  int now = 0;
  int cur_p = p;
  int v = 1;
  int mxw = ww[1];
  for (int u = 2; u <= n; ++u) {
    cur_p -= g[v].back().second;
    if (cur_p < 0) {
      int val = (abs(cur_p) + mxw - 1) / mxw;
      now += val;
      cur_p += mxw * val;
    }

    v = u;
    mxw = max(mxw, ww[u]);
  }
  ans = min(ans, now);
  cout << (ans == INF ? -1 : ans) << '\n';
}

void sol3(int n, int p) {
  for (int i = 1; i <= n; ++i) {
    dijkstra(i);
  }
  vector<int> perm(n - 1);
  iota(all(perm), 2);
  int ans = INF;
  do {
    int now = 0;
    int cur_p = p;
    int v = 1;
    for (int u : perm) {
      if (dists[v][u] == INF) {
        now = INF;
        break;
      }
      cur_p -= dists[v][u];
      if (cur_p >= 0) {
        continue;
      }
      int val = (abs(cur_p) + ww[v] - 1) / ww[v];
      now += val;
      cur_p += ww[v] * val;
      if (u == n) {
        break;
      }
      v = u;
    }
    ans = min(ans, now);
  } while (next_permutation(all(perm)));
  cout << (ans == INF ? -1 : ans) << '\n';
}

void sol(int n, int p) {
  for (int i = 1; i <= n; ++i) {
    dijkstra(i);
  }
  vector<pair<int, int>> a;
  for (int v = 1; v <= n; ++v) {
    a.emplace_back(ww[v], v);
  }
  sort(all(a));
  reverse(all(a));
  while (a.back().second != 1) {
    a.pop_back();
  }
  reverse(all(a));
  a.push_back({ww[n], n});
  int m = a.size();
  vector<map<int, int>> dp(m);
  dp[0][0] = p;
  for (int i = 0; i < m - 1; ++i) {
    int v = a[i].second;
    auto [best_cnt, best_p] = *dp[i].begin();
    vector<int> for_del;
    for (auto [cnt, cur_p] : dp[i]) {
      if ((cnt - best_cnt) * ww[v] > cur_p - best_p) {
        for_del.push_back(cnt);
      }
    }
    for (auto el : for_del) {
      dp[i].erase(el);
    }
    for (int j = i + 1; j < m; ++j) {
      int u = a[j].second;
      if (a[i].first == a[j].first) {
        continue;
      }
      for (auto [mn_cnt, mx_p] : dp[i]) {
        int d = dists[v][u];
        if (d == INF) {
          continue;
        }
        int cur_p = mx_p - d;
        int cur_cnt = mn_cnt;
        if (cur_p < 0) {
          int val = (abs(cur_p) + ww[v] - 1) / ww[v];
          cur_cnt += val;
          cur_p += ww[v] * val;
        }
        dp[j][cur_cnt] = max(dp[j][cur_cnt], cur_p);
      }
    }
  }
  int ans = INF;
  if (!dp[m - 1].empty()) {
    ans = dp[m - 1].begin()->first;
  }
  cout << (ans == INF ? -1 : ans) << '\n';
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  for (int i = 0; i < MAXN; ++i) {
    fill(dists[i], dists[i] + MAXN, INF);
  }
  int n, m, p, G;
  cin >> n >> m >> p >> G;
  for (int i = 1; i <= n; ++i) {
    cin >> ww[i];
  }
  for (int i = 0; i < m; ++i) {
    int u, v, w;
    cin >> u >> v >> w;
    g[u].emplace_back(v, w);
  }
//  if (G == 1) {
//    sol1(n, p);
//    return 0;
//  }
//  if (G == 2) {
//    sol2(n, p);
//    return 0;
//  }
//  if (G == 3 || G == 0) {
//    sol3(n, p);
//    return 0;
//  }
  sol(n, p);
}
