/*
    author:  Maksim1744
    created: 18.02.2023 12:50:04
*/

#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;

#define mp   make_pair
#define pb   push_back
#define eb   emplace_back

#define sum(a)     ( accumulate ((a).begin(), (a).end(), 0ll))
#define mine(a)    (*min_element((a).begin(), (a).end()))
#define maxe(a)    (*max_element((a).begin(), (a).end()))
#define mini(a)    ( min_element((a).begin(), (a).end()) - (a).begin())
#define maxi(a)    ( max_element((a).begin(), (a).end()) - (a).begin())
#define lowb(a, x) ( lower_bound((a).begin(), (a).end(), (x)) - (a).begin())
#define uppb(a, x) ( upper_bound((a).begin(), (a).end(), (x)) - (a).begin())

template<typename T>             vector<T>& operator--            (vector<T> &v){for (auto& i : v) --i;            return  v;}
template<typename T>             vector<T>& operator++            (vector<T> &v){for (auto& i : v) ++i;            return  v;}
template<typename T>             istream& operator>>(istream& is,  vector<T> &v){for (auto& i : v) is >> i;        return is;}
template<typename T>             ostream& operator<<(ostream& os,  vector<T>  v){for (auto& i : v) os << i << ' '; return os;}
template<typename T, typename U> pair<T,U>& operator--           (pair<T, U> &p){--p.first; --p.second;            return  p;}
template<typename T, typename U> pair<T,U>& operator++           (pair<T, U> &p){++p.first; ++p.second;            return  p;}
template<typename T, typename U> istream& operator>>(istream& is, pair<T, U> &p){is >> p.first >> p.second;        return is;}
template<typename T, typename U> ostream& operator<<(ostream& os, pair<T, U>  p){os << p.first << ' ' << p.second; return os;}
template<typename T, typename U> pair<T,U> operator-(pair<T,U> a, pair<T,U> b){return mp(a.first-b.first, a.second-b.second);}
template<typename T, typename U> pair<T,U> operator+(pair<T,U> a, pair<T,U> b){return mp(a.first+b.first, a.second+b.second);}
template<typename T, typename U> void umin(T& a, U b){if (a > b) a = b;}
template<typename T, typename U> void umax(T& a, U b){if (a < b) a = b;}

#ifdef HOME
#define SHOW_COLORS
#include "/mnt/c/Libs/tools/print.cpp"
#else
#define show(...) void(0)
#define debugf(fun)   fun
#define debugv(var)   var
#define mclock    void(0)
#define shows     void(0)
#define debug  if (false)
#define OSTREAM(...)    ;
#define OSTREAM0(...)   ;
#endif

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int n, m, p, _g;
    cin >> n >> m >> p >> _g;
    vector<ll> w(n);
    cin >> w;
    w.back() = 1e9 + 100;

    const ll inf = 1e18;

    vector<vector<ll>> dist(n, vector<ll>(n, inf));
    for (int i = 0; i < n; ++i) {
        dist[i][i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a; --b;
        dist[a][b] = min(dist[a][b], (ll)s);
    }

    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }

    if (dist[0][n - 1] == inf) {
        cout << -1 << "\n";
        return 0;
    }

    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return w[i] < w[j];
    });

    assert(ord.back() == n - 1);

    while (ord[0] != 0) ord.erase(ord.begin());

    vector<pair<ll, ll>> ans(ord.size(), {inf, -inf});
    ans[0] = {0, p};

    for (int i = 0; i < ans.size(); ++i) {
        for (int j = i + 1; j < ans.size(); ++j) {
            int u = ord[i];
            int v = ord[j];
            if (dist[u][v] == inf) continue;
            ll x = ans[i].first;
            ll money = ans[i].second;
            ll need = dist[u][v] - money;

            if (need > 0) {
                ll cnt = (need + w[u] - 1) / w[u];
                money += cnt * w[u];
                x += cnt;
            }
            money -= dist[u][v];
            assert(money >= 0);
            if (ans[j].first > x || (ans[j].first == x && ans[j].second < money))
                ans[j] = {x, money};
        }
    }

    cout << ans.back().first << '\n';

    return 0;
}
