#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <tuple>
#include <math.h>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <queue>
#include <random>
#include <array>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <unordered_map>

#define DEBUG
#define pqueue priority_queue
#define pb(x) push_back(x)
#define endl '\n'
#define all(x) x.begin(), x.end()
#define int long long
#define mk(a, b) make_pair(a, b)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ull> vull;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pair<int, int> > vpii;
typedef pair<ll, ll> pll;
typedef vector<bool> vb;
typedef vector<string> vs;
typedef vector<vector<int> > vvi;
typedef vector<char> vc;

const ll inf = 1e9 + 228;
const ll infll = 1e18;
const int mod = 1e9 + 7;
const ll mod3 = 1e9 + 7;
const ld eps = 1e-7;
const ll mod2 = 1e9 + 9;
const ld PI = atan2l(0, -1);

void fast_io() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int n, m, s, g;
    cin >> n >> m >> s >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<vector<pair<int, int>>> edges(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        edges[a].push_back({b, c});
    }
    vector<vector<pair<int, int>>> dp(n, vector<pair<int, int>>(n, {infll, infll}));
    dp[0][0] = {0, s};

    pqueue<pair<int, pair<int, int>>> q;
    q.push({0, {0, 0}});

    while (!q.empty()) {
        auto cur = q.top().second;
        q.pop();
        for (pii i: edges[cur.first]) {
            int cnt = dp[cur.first][cur.second].first;
            int cur_w = dp[cur.first][cur.second].second;
            if (cur_w < i.second) {
                int need = (i.second - cur_w + w[cur.second] - 1) / w[cur.second];
                cur_w += need * w[cur.second];
                cnt += need;
            }
            cur_w -= i.second;
            int mx = cur.second;
            if (w[mx] < w[i.first])
                mx = i.first;
            if (dp[i.first][mx].first > cnt || (dp[i.first][mx].first == cnt && dp[i.first][mx].second < cur_w)) {
                dp[i.first][mx] = {cnt, cur_w};
                q.push({dp[i.first][mx].first, {i.first, mx}});
            }
        }
    }

    int ans = min_element(dp[n - 1].begin(), dp[n - 1].end())->first;
    cout << (ans == infll ? -1 : ans) << endl;

}

signed main() {
    fast_io();
    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}
