#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
#include <random>
#include <queue>
#include <ctime>
#include <unordered_map>

#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

using namespace std;
const int mod = 1e9 + 7;
mt19937 rnd(1337 * 261 + 239);

signed main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	cout << fixed << setprecision(10);

	int n, m, p, g;
	cin >> n >> m >> p >> g;
	vector<int> w(n);
	for (auto &x: w) cin >> x;

	vector<vector<int>> e(m, vector<int>(3));
	for (auto &x: e) {
		for (auto &y: x) cin >> y;
		x[0]--, x[1]--;
	}
	vector<pair <int, int>> d(n, {mod * mod, 0});
	d[0] = {0, p};

	vector <vector <int>> dist(n, vector <int>(n, mod * mod));
	for (auto &x: e) {
		dist[x[0]][x[1]] = min(dist[x[0]][x[1]], x[2]);
	}

	for (int i = 0; i < n; ++i) dist[i][i] = 0;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int k = 0; k < n; ++k) {
				dist[j][k] = min(dist[j][k], dist[j][i] + dist[i][k]);
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int k = 0; k < n; ++k) {
				if (k != n - 1 and w[k] <= w[j]) continue;
				int W = dist[j][k];
				int need = (W - d[j].second);
				int add = 0, addCash = 0;
				if (need >= 0) {
					add = (need + w[j] - 1) / w[j];
					addCash = add * w[j];
				}
				pair <int, int> newD = d[j];
				newD.first += add;
				newD.second += addCash - W;
				if (newD.first < d[k].first or (newD.first == d[k].first and newD.second > d[k].second)) d[k] = newD;
			}
		}
	}

	cout << d[n - 1].first << '\n';




	return 0;
}
